(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("jdataview"), require("pg-long"), require("lodash"), require("chai"), require("pg-crypt"));
	else if(typeof define === 'function' && define.amd)
		define(["jdataview", "pg-long", "lodash", "chai", "pg-crypt"], factory);
	else if(typeof exports === 'object')
		exports["msgpack-javascript"] = factory(require("jdataview"), require("pg-long"), require("lodash"), require("chai"), require("pg-crypt"));
	else
		root["msgpack-javascript"] = factory(root["jdataview"], root["pg-long"], root["lodash"], root["chai"], root["pg-crypt"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_9__, __WEBPACK_EXTERNAL_MODULE_10__, __WEBPACK_EXTERNAL_MODULE_11__, __WEBPACK_EXTERNAL_MODULE_12__, __WEBPACK_EXTERNAL_MODULE_13__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var _Object$defineProperty = __webpack_require__(7)['default'];
	
	var _interopRequireDefault = __webpack_require__(8)['default'];
	
	_Object$defineProperty(exports, '__esModule', {
	  value: true
	});
	
	var _messagePrefix = __webpack_require__(2);
	
	var _messagePrefix2 = _interopRequireDefault(_messagePrefix);
	
	var _messageScale = __webpack_require__(1);
	
	var _messageScale2 = _interopRequireDefault(_messageScale);
	
	var _messagePacker = __webpack_require__(3);
	
	var _messagePacker2 = _interopRequireDefault(_messagePacker);
	
	var _messageUnpacker = __webpack_require__(4);
	
	var _messageUnpacker2 = _interopRequireDefault(_messageUnpacker);
	
	var _valueType = __webpack_require__(5);
	
	var _valueType2 = _interopRequireDefault(_valueType);
	
	var _numberType = __webpack_require__(6);
	
	var _numberType2 = _interopRequireDefault(_numberType);
	
	exports['default'] = { Prefix: _messagePrefix2['default'], Packer: _messagePacker2['default'], Unpacker: _messageUnpacker2['default'], Scale: _messageScale2['default'], ValueType: _valueType2['default'], NumberType: _numberType2['default'] };
	module.exports = exports['default'];

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var _createClass = __webpack_require__(14)['default'];
	
	var _classCallCheck = __webpack_require__(15)['default'];
	
	var _inherits = __webpack_require__(16)['default'];
	
	var _get = __webpack_require__(17)['default'];
	
	var _Object$defineProperty = __webpack_require__(7)['default'];
	
	var _interopRequireDefault = __webpack_require__(8)['default'];
	
	_Object$defineProperty(exports, '__esModule', {
	  value: true
	});
	
	var _messagePacker = __webpack_require__(3);
	
	var _messagePacker2 = _interopRequireDefault(_messagePacker);
	
	var MockDataView = (function () {
	  function MockDataView() {
	    _classCallCheck(this, MockDataView);
	  }
	
	  _createClass(MockDataView, [{
	    key: 'setInt8',
	    value: function setInt8() {}
	  }, {
	    key: 'setUint8',
	    value: function setUint8() {}
	  }, {
	    key: 'setInt16',
	    value: function setInt16() {}
	  }, {
	    key: 'setUint16',
	    value: function setUint16() {}
	  }, {
	    key: 'setInt32',
	    value: function setInt32() {}
	  }, {
	    key: 'setUint32',
	    value: function setUint32() {}
	  }, {
	    key: 'setFloat32',
	    value: function setFloat32() {}
	  }, {
	    key: 'setFloat64',
	    value: function setFloat64() {}
	  }]);
	
	  return MockDataView;
	})();
	
	var MessageScale = (function (_MessagePacker) {
	  function MessageScale() {
	    _classCallCheck(this, MessageScale);
	
	    _get(Object.getPrototypeOf(MessageScale.prototype), 'constructor', this).call(this);
	    this.$dv = new MockDataView();
	  }
	
	  _inherits(MessageScale, _MessagePacker);
	
	  return MessageScale;
	})(_messagePacker2['default']);
	
	exports['default'] = MessageScale;
	module.exports = exports['default'];

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	var _createClass = __webpack_require__(14)["default"];
	
	var _classCallCheck = __webpack_require__(15)["default"];
	
	var _Object$defineProperty = __webpack_require__(7)["default"];
	
	_Object$defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var Prefix = (function () {
	  function Prefix() {
	    _classCallCheck(this, Prefix);
	  }
	
	  _createClass(Prefix, null, [{
	    key: "isFixInt",
	    value: function isFixInt(b) {
	      var v = b & 255;
	      return v <= 127 || v >= 224;
	    }
	  }, {
	    key: "isPosFixInt",
	    value: function isPosFixInt(b) {
	      return (b & Prefix.POSFIXINT_MASK) === 0;
	    }
	  }, {
	    key: "isNegFixInt",
	    value: function isNegFixInt(b) {
	      return (b & Prefix.NEGFIXINT_PREFIX) === Prefix.NEGFIXINT_PREFIX;
	    }
	  }, {
	    key: "isFixStr",
	    value: function isFixStr(b) {
	      return (b & 224) === Prefix.FIXSTR_PREFIX;
	    }
	  }, {
	    key: "isFixedArray",
	    value: function isFixedArray(b) {
	      return (b & 240) === Prefix.FIXARRAY_PREFIX;
	    }
	  }, {
	    key: "isFixedMap",
	    value: function isFixedMap(b) {
	      return (b & 224) === Prefix.FIXMAP_PREFIX;
	    }
	  }, {
	    key: "isFixedRaw",
	    value: function isFixedRaw(b) {
	      return (b & 224) === Prefix.FIXSTR_PREFIX;
	    }
	  }, {
	    key: "POSFIXINT_MASK",
	    get: function () {
	      return 128;
	    }
	  }, {
	    key: "FIXMAP_PREFIX",
	    get: function () {
	      return 128;
	    }
	  }, {
	    key: "FIXARRAY_PREFIX",
	    get: function () {
	      return 144;
	    }
	  }, {
	    key: "FIXSTR_PREFIX",
	    get: function () {
	      return 160;
	    }
	  }, {
	    key: "NIL",
	    get: function () {
	      return 192;
	    }
	  }, {
	    key: "NEVER_USED",
	    get: function () {
	      return 193;
	    }
	  }, {
	    key: "FALSE",
	    get: function () {
	      return 194;
	    }
	  }, {
	    key: "TRUE",
	    get: function () {
	      return 195;
	    }
	  }, {
	    key: "BIN8",
	    get: function () {
	      return 196;
	    }
	  }, {
	    key: "BIN16",
	    get: function () {
	      return 197;
	    }
	  }, {
	    key: "BIN32",
	    get: function () {
	      return 198;
	    }
	  }, {
	    key: "EXT8",
	    get: function () {
	      return 199;
	    }
	  }, {
	    key: "EXT16",
	    get: function () {
	      return 200;
	    }
	  }, {
	    key: "EXT32",
	    get: function () {
	      return 201;
	    }
	  }, {
	    key: "FLOAT32",
	    get: function () {
	      return 202;
	    }
	  }, {
	    key: "FLOAT64",
	    get: function () {
	      return 203;
	    }
	  }, {
	    key: "UINT8",
	    get: function () {
	      return 204;
	    }
	  }, {
	    key: "UINT16",
	    get: function () {
	      return 205;
	    }
	  }, {
	    key: "UINT32",
	    get: function () {
	      return 206;
	    }
	  }, {
	    key: "UINT64",
	    get: function () {
	      return 207;
	    }
	  }, {
	    key: "INT8",
	    get: function () {
	      return 208;
	    }
	  }, {
	    key: "INT16",
	    get: function () {
	      return 209;
	    }
	  }, {
	    key: "INT32",
	    get: function () {
	      return 210;
	    }
	  }, {
	    key: "INT64",
	    get: function () {
	      return 211;
	    }
	  }, {
	    key: "FIXEXT1",
	    get: function () {
	      return 212;
	    }
	  }, {
	    key: "FIXEXT2",
	    get: function () {
	      return 213;
	    }
	  }, {
	    key: "FIXEXT4",
	    get: function () {
	      return 214;
	    }
	  }, {
	    key: "FIXEXT8",
	    get: function () {
	      return 215;
	    }
	  }, {
	    key: "FIXEXT16",
	    get: function () {
	      return 216;
	    }
	  }, {
	    key: "STR8",
	    get: function () {
	      return 217;
	    }
	  }, {
	    key: "STR16",
	    get: function () {
	      return 218;
	    }
	  }, {
	    key: "STR32",
	    get: function () {
	      return 219;
	    }
	  }, {
	    key: "ARRAY16",
	    get: function () {
	      return 220;
	    }
	  }, {
	    key: "ARRAY32",
	    get: function () {
	      return 221;
	    }
	  }, {
	    key: "MAP16",
	    get: function () {
	      return 222;
	    }
	  }, {
	    key: "MAP32",
	    get: function () {
	      return 223;
	    }
	  }, {
	    key: "NEGFIXINT_PREFIX",
	    get: function () {
	      return 224;
	    }
	  }]);
	
	  return Prefix;
	})();
	
	exports["default"] = Prefix;
	module.exports = exports["default"];

/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(Buffer) {'use strict';
	
	var _createClass = __webpack_require__(14)['default'];
	
	var _classCallCheck = __webpack_require__(15)['default'];
	
	var _Object$defineProperty = __webpack_require__(7)['default'];
	
	var _Map = __webpack_require__(18)['default'];
	
	var _interopRequireDefault = __webpack_require__(8)['default'];
	
	_Object$defineProperty(exports, '__esModule', {
	  value: true
	});
	
	var _jdataview = __webpack_require__(9);
	
	var _jdataview2 = _interopRequireDefault(_jdataview);
	
	var _pgLong = __webpack_require__(10);
	
	var _pgLong2 = _interopRequireDefault(_pgLong);
	
	var _messagePrefix = __webpack_require__(2);
	
	var _messagePrefix2 = _interopRequireDefault(_messagePrefix);
	
	var _numberType = __webpack_require__(6);
	
	var _numberType2 = _interopRequireDefault(_numberType);
	
	var _valueType = __webpack_require__(5);
	
	var _valueType2 = _interopRequireDefault(_valueType);
	
	var _lodash = __webpack_require__(11);
	
	var _lodash2 = _interopRequireDefault(_lodash);
	
	var _chai = __webpack_require__(12);
	
	var _pgCrypt = __webpack_require__(13);
	
	var isArrayLike = function isArrayLike(value) {
	  return _lodash2['default'].isArray(value) || value instanceof Buffer || value instanceof Uint8Array;
	};
	
	var MessagePacker = (function () {
	  function MessagePacker(length) {
	    var _this = this;
	
	    _classCallCheck(this, MessagePacker);
	
	    this.$dv = new _jdataview2['default'](length || 512);
	    this.$position = 0;
	
	    this.writeByte = function (byte) {
	      _this.$dv[byte < 0 ? 'setInt8' : 'setUint8'](_this.$position++, byte);
	    };
	
	    this.writeShort = function (short) {
	      _this.writeByte(short < 0 ? _messagePrefix2['default'].INT16 : _messagePrefix2['default'].UINT16);
	      _this.$dv[short < 0 ? 'setInt16' : 'setUint16'](_this.$position, short);
	      _this.$position += 2;
	    };
	
	    this.writeInt = function (int) {
	      _this.writeByte(int < 0 ? _messagePrefix2['default'].INT32 : _messagePrefix2['default'].UINT32);
	      _this.$dv[int < 0 ? 'setInt32' : 'setUint32'](_this.$position, int);
	      _this.$position += 4;
	    };
	
	    this.writeLong = function (value) {
	      var long = value;
	      if (!_pgLong2['default'].isLong(long)) {
	        long = _pgLong2['default'].fromNumber(long);
	      }
	      _this.writeByte(long.lessThan(_pgLong2['default'].ZERO) ? _messagePrefix2['default'].INT64 : _messagePrefix2['default'].UINT64);
	      _this.$dv.setInt32(_this.$position, long.getHighBits());
	      _this.$dv.setInt32(_this.$position + 4, long.getLowBits());
	      _this.$position += 8;
	    };
	
	    this.writeFloat = function (float) {
	      _this.writeByte(_messagePrefix2['default'].FLOAT32);
	      _this.$dv.setFloat32(_this.$position, float);
	      _this.$position += 4;
	    };
	
	    this.writeDouble = function (double) {
	      _this.writeByte(_messagePrefix2['default'].FLOAT64);
	      _this.$dv.setFloat64(_this.$position, double);
	      _this.$position += 8;
	    };
	
	    this.writePayload = function (source, offset, len) {
	      (0, _chai.assert)(isArrayLike(source));
	      var o = offset || 0,
	          l = len || source.length,
	          i = undefined;
	      for (i = o; i < l; i++) {
	        _this.writeByte(source[i]);
	      }
	    };
	  }
	
	  _createClass(MessagePacker, [{
	    key: 'getBytes',
	    value: function getBytes() {
	      return this.$dv.getBytes(this.$position, 0);
	    }
	  }, {
	    key: 'position',
	    get: function () {
	      return this.$position;
	    }
	  }, {
	    key: 'packNil',
	    value: function packNil() {
	      this.writeByte(_messagePrefix2['default'].NIL);
	      return this;
	    }
	  }, {
	    key: 'packBoolean',
	    value: function packBoolean(value) {
	      _chai.assert.isBoolean(value);
	      this.writeByte(value ? _messagePrefix2['default'].TRUE : _messagePrefix2['default'].FALSE);
	      return this;
	    }
	  }, {
	    key: 'packInt',
	    value: function packInt(value) {
	      _chai.assert.isTrue(_numberType2['default'].LONG.contains(value), 'expected value within Long range');
	      switch (_numberType2['default'].valueOf(value)) {
	        case _numberType2['default'].FIXNUM:
	          this.writeByte(value);
	          break;
	        case _numberType2['default'].BYTE:
	          this.writeByte(value < 0 ? _messagePrefix2['default'].INT8 : _messagePrefix2['default'].UINT8);
	          this.writeByte(value);
	          break;
	        case _numberType2['default'].SHORT:
	          this.writeShort(value);
	          break;
	        case _numberType2['default'].INTEGER:
	          this.writeInt(value);
	          break;
	        default:
	          this.writeLong(value);
	      }
	      return this;
	    }
	  }, {
	    key: 'packFloat',
	    value: function packFloat(value) {
	      _chai.assert.isTrue(_numberType2['default'].isFloat(value));
	      this.writeFloat(value);
	      return this;
	    }
	  }, {
	    key: 'packDouble',
	    value: function packDouble(value) {
	      _chai.assert.isTrue(_numberType2['default'].isDouble(value));
	      this.writeDouble(value);
	      return this;
	    }
	  }, {
	    key: 'packString',
	    value: function packString(value) {
	      _chai.assert.isString(value);
	      var v = (0, _pgCrypt.stringToUtf8ByteArray)(value);
	      this.packRawStringHeader(v.length);
	      this.writePayload(v);
	      return this;
	    }
	  }, {
	    key: 'packValue',
	    value: function packValue(value) {
	      var type = _valueType2['default'].valueOf(value),
	          method = undefined;
	      switch (type) {
	        case _valueType2['default'].NIL:
	          method = 'Nil';
	          break;
	        case _valueType2['default'].BOOLEAN:
	          method = 'Boolean';
	          break;
	        case _valueType2['default'].INTEGER:
	          method = 'Int';
	          break;
	        case _valueType2['default'].FLOAT:
	          method = _numberType2['default'].isFloat(value) ? 'Float' : 'Double';
	          break;
	        case _valueType2['default'].STRING:
	          method = 'String';
	          break;
	        case _valueType2['default'].BINARY:
	          method = 'Binary';
	          break;
	        case _valueType2['default'].ARRAY:
	          method = 'Array';
	          break;
	        case _valueType2['default'].MAP:
	          method = 'Map';
	          break;
	        default:
	          throw new Error('unhandled value type for value ' + value);
	      }
	      this['pack' + method].call(this, value);
	    }
	  }, {
	    key: 'packArray',
	    value: function packArray(array) {
	      _chai.assert.isArray(array);
	
	      if (_valueType2['default'].BINARY.contains(array)) {
	        return this.packBinary(array);
	      }
	
	      this.packArrayHeader(array.length);
	
	      array.forEach(function (item) {
	        this.packValue(item);
	      }, this);
	
	      return this;
	    }
	  }, {
	    key: 'packArrayHeader',
	    value: function packArrayHeader(size) {
	      _chai.assert.isNumber(size);
	      _chai.assert.isTrue(size > 0);
	      _chai.assert.isBelow(size, _numberType2['default'].INTEGER.maxValue + 1);
	
	      if (size < 1 << 4) {
	        this.writeByte(_messagePrefix2['default'].FIXARRAY_PREFIX | size);
	      } else if (size < 1 << 16) {
	        this.writeByte(_messagePrefix2['default'].ARRAY16);
	        this.writeShort(size);
	      } else {
	        this.writeByte(_messagePrefix2['default'].ARRAY32);
	        this.writeInt(size);
	      }
	      return this;
	    }
	  }, {
	    key: 'packMap',
	    value: function packMap(map) {
	      (0, _chai.assert)(map instanceof _Map, 'expected Map');
	
	      this.packMapHeader(map.size);
	
	      map.forEach(function (value, key) {
	        this.packValue(key);
	        this.packValue(value);
	      }, this);
	
	      return this;
	    }
	  }, {
	    key: 'packMapHeader',
	    value: function packMapHeader(size) {
	      _chai.assert.isNumber(size);
	      _chai.assert.isTrue(size > 0);
	      _chai.assert.isBelow(size, _numberType2['default'].INTEGER.maxValue + 1);
	
	      if (size < 1 << 4) {
	        this.writeByte(_messagePrefix2['default'].FIXMAP_PREFIX | size);
	      } else if (size < 1 << 16) {
	        this.writeByte(_messagePrefix2['default'].MAP16);
	        this.writeShort(size);
	      } else {
	        this.writeByte(_messagePrefix2['default'].MAP32);
	        this.writeInt(size);
	      }
	      return this;
	    }
	  }, {
	    key: 'packBinary',
	    value: function packBinary(array) {
	      _chai.assert.isTrue(_valueType2['default'].BINARY.contains(array), 'expected byte array');
	
	      this.packBinaryHeader(array.length);
	      this.writePayload(array);
	
	      return this;
	    }
	  }, {
	    key: 'packBinaryHeader',
	    value: function packBinaryHeader(length) {
	      _chai.assert.isNumber(length);
	      _chai.assert.isTrue(length > 0);
	      _chai.assert.isBelow(length, _numberType2['default'].INTEGER.maxValue + 1);
	
	      if (length < 1 << 8) {
	        this.writeByte(_messagePrefix2['default'].BIN8);
	        this.writeByte(length);
	      } else if (length < 1 << 16) {
	        this.writeByte(_messagePrefix2['default'].BIN16);
	        this.writeShort(length);
	      } else {
	        this.writeByte(_messagePrefix2['default'].BIN32);
	        this.writeInt(length);
	      }
	      return this;
	    }
	  }, {
	    key: 'packRawStringHeader',
	    value: function packRawStringHeader(length) {
	      _chai.assert.isNumber(length);
	      _chai.assert.isTrue(length > 0);
	      _chai.assert.isBelow(length, _numberType2['default'].INTEGER.maxValue + 1);
	
	      if (length < 1 << 5) {
	        this.writeByte(_messagePrefix2['default'].FIXSTR_PREFIX | length);
	      } else if (length < 1 << 8) {
	        this.writeByte(_messagePrefix2['default'].STR8);
	        this.writeByte(length);
	      } else if (length < 1 << 16) {
	        this.writeByte(_messagePrefix2['default'].STR16);
	        this.writeShort(length);
	      } else {
	        this.writeByte(_messagePrefix2['default'].STR32);
	        this.writeInt(length);
	      }
	      return this;
	    }
	  }, {
	    key: 'packExtendedTypeHeader',
	    value: function packExtendedTypeHeader(extType, payloadLength) {
	      _chai.assert.isNumber(extType);
	      _chai.assert.isNumber(payloadLength);
	      _chai.assert.isBelow(payloadLength, _numberType2['default'].INTEGER.maxValue + 1, 'expected payloadLength < ' + _numberType2['default'].INTEGER.maxValue + 1);
	
	      if (payloadLength < 1 << 8) {
	        switch (payloadLength) {
	          case 1:
	            this.writeByte(_messagePrefix2['default'].FIXEXT1);
	            this.writeByte(extType);
	            break;
	          case 2:
	            this.writeByte(_messagePrefix2['default'].FIXEXT2);
	            this.writeByte(extType);
	            break;
	          case 4:
	            this.writeByte(_messagePrefix2['default'].FIXEXT4);
	            this.writeByte(extType);
	            break;
	          case 8:
	            this.writeByte(_messagePrefix2['default'].FIXEXT8);
	            this.writeByte(extType);
	            break;
	          case 16:
	            this.writeByte(_messagePrefix2['default'].FIXEXT16);
	            this.writeByte(extType);
	            break;
	          default:
	            this.writeByte(_messagePrefix2['default'].EXT8);
	            this.writeByte(payloadLength);
	            this.writeByte(extType);
	        }
	      } else if (payloadLength < 1 << 16) {
	        this.writeByte(_messagePrefix2['default'].EXT16);
	        this.writeShort(payloadLength);
	        this.writeByte(extType);
	      } else {
	        this.writeByte(_messagePrefix2['default'].EXT32);
	        this.writeInt(payloadLength);
	        this.writeByte(extType);
	      }
	      return this;
	    }
	  }]);
	
	  return MessagePacker;
	})();
	
	exports['default'] = MessagePacker;
	module.exports = exports['default'];
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(19).Buffer))

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var _createClass = __webpack_require__(14)['default'];
	
	var _classCallCheck = __webpack_require__(15)['default'];
	
	var _Object$defineProperty = __webpack_require__(7)['default'];
	
	var _Map = __webpack_require__(18)['default'];
	
	var _interopRequireDefault = __webpack_require__(8)['default'];
	
	_Object$defineProperty(exports, '__esModule', {
	  value: true
	});
	
	var _jdataview = __webpack_require__(9);
	
	var _jdataview2 = _interopRequireDefault(_jdataview);
	
	var _pgLong = __webpack_require__(10);
	
	var _pgLong2 = _interopRequireDefault(_pgLong);
	
	var _messagePrefix = __webpack_require__(2);
	
	var _messagePrefix2 = _interopRequireDefault(_messagePrefix);
	
	var _valueType = __webpack_require__(5);
	
	var _valueType2 = _interopRequireDefault(_valueType);
	
	var _chai = __webpack_require__(12);
	
	var _pgCrypt = __webpack_require__(13);
	
	var MessageUnpacker = (function () {
	  function MessageUnpacker(bytesOrBuffer) {
	    _classCallCheck(this, MessageUnpacker);
	
	    this.$dv = new _jdataview2['default'](bytesOrBuffer);
	    this.$position = 0;
	
	    this.readByte = function () {
	      return this.$dv.getUint8(this.$position++);
	    };
	
	    this.readSignedByte = function () {
	      return this.$dv.getInt8(this.$position++);
	    };
	
	    this.readShort = function () {
	      var prefix = this.readByte(),
	          value = undefined;
	      _chai.assert.include([_messagePrefix2['default'].INT16, _messagePrefix2['default'].UINT16], prefix);
	      value = this.$dv[prefix === _messagePrefix2['default'].INT16 ? 'getInt16' : 'getUint16'](this.$position);
	      this.$position += 2;
	      return value;
	    };
	
	    this.readInt = function () {
	      var prefix = this.readByte(),
	          value = undefined;
	      _chai.assert.include([_messagePrefix2['default'].INT32, _messagePrefix2['default'].UINT32], prefix);
	      value = this.$dv[prefix === _messagePrefix2['default'].INT32 ? 'getInt32' : 'getUint32'](this.$position);
	      this.$position += 4;
	      return value;
	    };
	
	    this.readLong = function () {
	      var prefix = this.readByte(),
	          highBits = undefined,
	          lowBits = undefined;
	      _chai.assert.include([_messagePrefix2['default'].INT64, _messagePrefix2['default'].UINT64], prefix);
	      highBits = this.$dv.getInt32(this.$position);
	      lowBits = this.$dv.getInt32(this.$position + 4);
	      this.$position += 8;
	      return _pgLong2['default'].fromBits(lowBits, highBits, prefix === _messagePrefix2['default'].UINT64);
	    };
	
	    this.readFloat = function () {
	      _chai.assert.strictEqual(_messagePrefix2['default'].FLOAT32, this.readByte());
	      var value = this.$dv.getFloat32(this.$position);
	      this.$position += 4;
	      return value;
	    };
	
	    this.readDouble = function () {
	      _chai.assert.strictEqual(_messagePrefix2['default'].FLOAT64, this.readByte());
	      var value = this.$dv.getFloat64(this.$position);
	      this.$position += 8;
	      return value;
	    };
	
	    this.readPayload = function (length) {
	      var value = this.$dv.getBytes(length, this.$position);
	      this.$position += length;
	      return value;
	    };
	
	    this.peek = function () {
	      return this.$dv.getUint8(this.$position);
	    };
	  }
	
	  _createClass(MessageUnpacker, [{
	    key: 'position',
	    get: function () {
	      return this.$position;
	    }
	  }, {
	    key: 'getBytes',
	    value: function getBytes() {
	      return this.$dv.getBytes();
	    }
	  }, {
	    key: 'unpackNil',
	    value: function unpackNil() {
	      _chai.assert.strictEqual(this.readByte(), _messagePrefix2['default'].NIL);
	    }
	  }, {
	    key: 'unpackBoolean',
	    value: function unpackBoolean() {
	      var prefix = this.readByte();
	      _chai.assert.include([_messagePrefix2['default'].TRUE, _messagePrefix2['default'].FALSE], prefix);
	      return prefix === _messagePrefix2['default'].TRUE;
	    }
	  }, {
	    key: 'unpackInt',
	    value: function unpackInt() {
	      var prefix = this.peek();
	
	      if (_messagePrefix2['default'].isFixInt(prefix)) {
	        return _messagePrefix2['default'].isPosFixInt(prefix) ? this.readByte() : this.readSignedByte();
	      }
	      switch (prefix) {
	        case _messagePrefix2['default'].INT8:
	          this.readByte();
	          return this.readSignedByte();
	        case _messagePrefix2['default'].UINT8:
	          this.readByte();
	          return this.readByte();
	        case _messagePrefix2['default'].INT16:
	        case _messagePrefix2['default'].UINT16:
	          return this.readShort();
	        case _messagePrefix2['default'].INT32:
	        case _messagePrefix2['default'].UINT32:
	          return this.readInt();
	        case _messagePrefix2['default'].INT64:
	        case _messagePrefix2['default'].UINT64:
	          return this.readLong();
	        default:
	          throw new Error('Unexpected int prefix: ' + prefix);
	      }
	    }
	  }, {
	    key: 'unpackFloat',
	    value: function unpackFloat() {
	      return this.readFloat();
	    }
	  }, {
	    key: 'unpackDouble',
	    value: function unpackDouble() {
	      return this.readDouble();
	    }
	  }, {
	    key: 'unpackString',
	    value: function unpackString() {
	      return (0, _pgCrypt.utf8ByteArrayToString)(this.readPayload(this.unpackRawStringHeader()));
	    }
	  }, {
	    key: 'unpackValue',
	    value: function unpackValue() {
	      var prefix = this.peek();
	      switch (_valueType2['default'].typeOf(prefix)) {
	        case _valueType2['default'].NIL:
	          return this.unpackNil();
	        case _valueType2['default'].BOOLEAN:
	          return this.unpackBoolean();
	        case _valueType2['default'].INTEGER:
	          return this.unpackInt();
	        case _valueType2['default'].FLOAT:
	          return prefix === _messagePrefix2['default'].FLOAT32 ? this.unpackFloat() : this.unpackDouble();
	        case _valueType2['default'].STRING:
	          return this.unpackString();
	        case _valueType2['default'].ARRAY:
	          return this.unpackArray();
	        case _valueType2['default'].BINARY:
	          return this.unpackBinary();
	        case _valueType2['default'].MAP:
	          return this.unpackMap();
	        default:
	          throw new Error('unknown prefix ' + prefix);
	      }
	    }
	  }, {
	    key: 'unpackArray',
	    value: function unpackArray() {
	      var size = this.unpackArrayHeader(),
	          array = [],
	          i = undefined;
	
	      for (i = 0; i < size; i++) {
	        array.push(this.unpackValue());
	      }
	
	      return array;
	    }
	  }, {
	    key: 'unpackArrayHeader',
	    value: function unpackArrayHeader() {
	      var prefix = this.readByte();
	
	      if (_messagePrefix2['default'].isFixedArray(prefix)) {
	        return prefix & 15;
	      }
	
	      switch (prefix) {
	        case _messagePrefix2['default'].ARRAY16:
	          return this.readShort();
	        case _messagePrefix2['default'].ARRAY32:
	          return this.readInt();
	        default:
	          throw new Error('Unexpected array header prefix: ' + prefix);
	      }
	    }
	  }, {
	    key: 'unpackMap',
	    value: function unpackMap() {
	      var size = this.unpackMapHeader(),
	          map = new _Map(),
	          i = undefined;
	
	      for (i = 0; i < size; i++) {
	        map.set(this.unpackValue(), this.unpackValue());
	      }
	
	      return map;
	    }
	  }, {
	    key: 'unpackMapHeader',
	    value: function unpackMapHeader() {
	      var prefix = this.readByte();
	
	      if (_messagePrefix2['default'].isFixedMap(prefix)) {
	        return prefix & 31;
	      }
	
	      switch (prefix) {
	        case _messagePrefix2['default'].MAP16:
	          return this.readShort();
	        case _messagePrefix2['default'].MAP32:
	          return this.readInt();
	        default:
	          throw new Error('Unexpected map header prefix: ' + prefix);
	      }
	    }
	  }, {
	    key: 'unpackBinary',
	    value: function unpackBinary() {
	      return this.readPayload(this.unpackBinaryHeader());
	    }
	  }, {
	    key: 'unpackBinaryHeader',
	    value: function unpackBinaryHeader() {
	      var prefix = this.readByte();
	
	      switch (prefix) {
	        case _messagePrefix2['default'].BIN8:
	          return this.readByte();
	        case _messagePrefix2['default'].BIN16:
	          return this.readShort();
	        case _messagePrefix2['default'].BIN32:
	          return this.readInt();
	        default:
	          throw new Error('Unexpected binary header prefix: ' + prefix);
	      }
	    }
	  }, {
	    key: 'unpackRawStringHeader',
	    value: function unpackRawStringHeader() {
	      var prefix = this.readByte();
	
	      if (_messagePrefix2['default'].isFixedRaw(prefix)) {
	        return prefix & 31;
	      }
	
	      switch (prefix) {
	        case _messagePrefix2['default'].STR8:
	          return this.readByte();
	        case _messagePrefix2['default'].STR16:
	          return this.readShort();
	        case _messagePrefix2['default'].STR32:
	          return this.readInt();
	        default:
	          throw new Error('Unexpected raw string header prefix: ' + prefix);
	      }
	    }
	  }, {
	    key: 'unpackExtendedTypeHeader',
	    value: function unpackExtendedTypeHeader() {
	      var prefix = this.readByte();
	      switch (prefix) {
	        case _messagePrefix2['default'].FIXEXT1:
	          return { length: 1, type: this.readByte() };
	        case _messagePrefix2['default'].FIXEXT2:
	          return { length: 2, type: this.readByte() };
	        case _messagePrefix2['default'].FIXEXT4:
	          return { length: 4, type: this.readByte() };
	        case _messagePrefix2['default'].FIXEXT8:
	          return { length: 8, type: this.readByte() };
	        case _messagePrefix2['default'].FIXEXT16:
	          return { length: 16, type: this.readByte() };
	        case _messagePrefix2['default'].EXT8:
	          return { length: this.readByte(), type: this.readByte() };
	        case _messagePrefix2['default'].EXT16:
	          return { length: this.readShort(), type: this.readByte() };
	        case _messagePrefix2['default'].EXT32:
	          return { length: this.readInt(), type: this.readByte() };
	        default:
	          throw new Error('Unexpected extended type header prefix: ' + prefix);
	      }
	    }
	  }]);
	
	  return MessageUnpacker;
	})();
	
	exports['default'] = MessageUnpacker;
	module.exports = exports['default'];

/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(Buffer) {'use strict';
	
	var _createClass = __webpack_require__(14)['default'];
	
	var _classCallCheck = __webpack_require__(15)['default'];
	
	var _Object$defineProperty = __webpack_require__(7)['default'];
	
	var _Map = __webpack_require__(18)['default'];
	
	var _interopRequireDefault = __webpack_require__(8)['default'];
	
	_Object$defineProperty(exports, '__esModule', {
	  value: true
	});
	
	var _pgLong = __webpack_require__(10);
	
	var _pgLong2 = _interopRequireDefault(_pgLong);
	
	var _messagePrefix = __webpack_require__(2);
	
	var _messagePrefix2 = _interopRequireDefault(_messagePrefix);
	
	var _numberType = __webpack_require__(6);
	
	var _numberType2 = _interopRequireDefault(_numberType);
	
	var _lodash = __webpack_require__(11);
	
	var _lodash2 = _interopRequireDefault(_lodash);
	
	function isArray(x) {
	  return _lodash2['default'].isArray(x) || x instanceof Uint8Array || x instanceof Buffer;
	}
	
	var NIL = undefined,
	    BOOLEAN = undefined,
	    INTEGER = undefined,
	    FLOAT = undefined,
	    STRING = undefined,
	    BINARY = undefined,
	    ARRAY = undefined,
	    MAP = undefined,
	    EXTENDED = undefined;
	
	var ValueType = (function () {
	  function ValueType(ordinal, numberType, rawType, contains) {
	    _classCallCheck(this, ValueType);
	
	    this.ordinal = ordinal;
	    this.numberType = numberType;
	    this.rawType = rawType;
	    this.bitMask = 1 << this.ordinal;
	    this.contains = contains;
	  }
	
	  _createClass(ValueType, [{
	    key: 'getBitMask',
	    value: function getBitMask() {
	      return this.bitMask;
	    }
	  }, {
	    key: 'isTypeOf',
	    value: function isTypeOf(bitMask) {
	      return (this.bitMask & bitMask) !== 0;
	    }
	  }, {
	    key: 'isNilType',
	    value: function isNilType() {
	      return this === NIL;
	    }
	  }, {
	    key: 'isBooleanType',
	    value: function isBooleanType() {
	      return this === BOOLEAN;
	    }
	  }, {
	    key: 'isNumberType',
	    value: function isNumberType() {
	      return this.numberType;
	    }
	  }, {
	    key: 'isIntegerType',
	    value: function isIntegerType() {
	      return this === INTEGER;
	    }
	  }, {
	    key: 'isFloatType',
	    value: function isFloatType() {
	      return this === FLOAT;
	    }
	  }, {
	    key: 'isRawType',
	    value: function isRawType() {
	      return this.rawType;
	    }
	  }, {
	    key: 'isStringType',
	    value: function isStringType() {
	      return this === STRING;
	    }
	  }, {
	    key: 'isBinaryType',
	    value: function isBinaryType() {
	      return this === BINARY;
	    }
	  }, {
	    key: 'isArrayType',
	    value: function isArrayType() {
	      return this === ARRAY;
	    }
	  }, {
	    key: 'isMapType',
	    value: function isMapType() {
	      return this === MAP;
	    }
	  }, {
	    key: 'isExtendedType',
	    value: function isExtendedType() {
	      return this === EXTENDED;
	    }
	  }]);
	
	  return ValueType;
	})();
	
	NIL = new ValueType(0, false, false, function (x) {
	  return _lodash2['default'].isNull(x) || _lodash2['default'].isUndefined(x);
	});
	BOOLEAN = new ValueType(1, false, false, _lodash2['default'].isBoolean);
	INTEGER = new ValueType(2, true, false, function (x) {
	  return _numberType2['default'].isInteger(x) || _pgLong2['default'].isLong(x);
	});
	FLOAT = new ValueType(3, true, false, function (x) {
	  return _numberType2['default'].isFloat(x) || _numberType2['default'].isDouble(x);
	});
	STRING = new ValueType(4, false, true, _lodash2['default'].isString);
	BINARY = new ValueType(5, false, true, function (x) {
	  return isArray(x) && _lodash2['default'].every(x, function (e) {
	    return _numberType2['default'].isInteger(e) && _numberType2['default'].BYTE.contains(e);
	  });
	});
	ARRAY = new ValueType(6, false, false, _lodash2['default'].isArray);
	MAP = new ValueType(7, false, false, function (x) {
	  return x instanceof _Map;
	});
	EXTENDED = new ValueType(8, false, true, function () {
	  return true;
	});
	
	function valueOf(x) {
	  return _lodash2['default'].find([NIL, BOOLEAN, INTEGER, FLOAT, STRING, BINARY, ARRAY, MAP, EXTENDED], function (type) {
	    return type.contains(x);
	  });
	}
	
	function typeOf(prefix) {
	  if (_messagePrefix2['default'].isFixInt(prefix)) {
	    return INTEGER;
	  } else if (_messagePrefix2['default'].isFixedArray(prefix)) {
	    return ARRAY;
	  } else if (_messagePrefix2['default'].isFixedMap(prefix)) {
	    return MAP;
	  } else if (_messagePrefix2['default'].isFixStr(prefix)) {
	    return STRING;
	  }
	
	  var type = undefined;
	
	  switch (prefix) {
	    case _messagePrefix2['default'].TRUE:
	    case _messagePrefix2['default'].FALSE:
	      type = BOOLEAN;
	      break;
	    case _messagePrefix2['default'].NIL:
	      type = NIL;
	      break;
	    case _messagePrefix2['default'].STR8:
	    case _messagePrefix2['default'].STR16:
	    case _messagePrefix2['default'].STR32:
	      type = STRING;
	      break;
	    case _messagePrefix2['default'].ARRAY16:
	    case _messagePrefix2['default'].ARRAY32:
	      type = ARRAY;
	      break;
	    case _messagePrefix2['default'].MAP16:
	    case _messagePrefix2['default'].MAP32:
	      type = MAP;
	      break;
	    case _messagePrefix2['default'].INT8:
	    case _messagePrefix2['default'].UINT8:
	    case _messagePrefix2['default'].INT16:
	    case _messagePrefix2['default'].UINT16:
	    case _messagePrefix2['default'].INT32:
	    case _messagePrefix2['default'].UINT32:
	    case _messagePrefix2['default'].INT64:
	    case _messagePrefix2['default'].UINT64:
	      type = INTEGER;
	      break;
	    case _messagePrefix2['default'].FLOAT32:
	    case _messagePrefix2['default'].FLOAT64:
	      type = FLOAT;
	      break;
	    case _messagePrefix2['default'].FIXEXT1:
	    case _messagePrefix2['default'].FIXEXT2:
	    case _messagePrefix2['default'].FIXEXT4:
	    case _messagePrefix2['default'].FIXEXT8:
	    case _messagePrefix2['default'].FIXEXT16:
	    case _messagePrefix2['default'].EXT8:
	    case _messagePrefix2['default'].EXT16:
	    case _messagePrefix2['default'].EXT32:
	      type = EXTENDED;
	      break;
	    case _messagePrefix2['default'].BIN8:
	    case _messagePrefix2['default'].BIN16:
	    case _messagePrefix2['default'].BIN32:
	      type = BINARY;
	      break;
	    default:
	      type = undefined;
	  }
	  return type;
	}
	
	function binariesEqual(thisB, thatB) {
	  if (!BINARY.contains(thisB) || !BINARY.contains(thatB)) {
	    return false;
	  }
	  return thisB.length === thatB.length && _lodash2['default'].every(thisB, function (element, index) {
	    return element === thatB[index];
	  });
	}
	
	exports['default'] = { NIL: NIL, BOOLEAN: BOOLEAN, INTEGER: INTEGER, FLOAT: FLOAT, STRING: STRING, BINARY: BINARY, ARRAY: ARRAY, MAP: MAP, EXTENDED: EXTENDED, valueOf: valueOf, typeOf: typeOf, binariesEqual: binariesEqual };
	module.exports = exports['default'];
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(19).Buffer))

/***/ },
/* 6 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var _createClass = __webpack_require__(14)['default'];
	
	var _classCallCheck = __webpack_require__(15)['default'];
	
	var _Object$defineProperty = __webpack_require__(7)['default'];
	
	var _interopRequireDefault = __webpack_require__(8)['default'];
	
	_Object$defineProperty(exports, '__esModule', {
	  value: true
	});
	
	var _lodash = __webpack_require__(11);
	
	var _lodash2 = _interopRequireDefault(_lodash);
	
	var _pgLong = __webpack_require__(10);
	
	var _pgLong2 = _interopRequireDefault(_pgLong);
	
	function isInteger(n) {
	  return +n === n && n % 1 === 0 && n.toString().indexOf('.') === -1;
	}
	
	function isFloat(n) {
	  return +n === n && Math.abs(n) <= 3.4028234663852886e+38;
	}
	
	function isDouble(n) {
	  return +n === n && Math.abs(n) <= 1.7976931348623157 * Math.pow(10, 308);
	}
	
	function floatsEqual(a, b, p) {
	  var precision = p || 3;
	  return isDouble(a) && isDouble(b) && a.toFixed(precision) === b.toFixed(precision);
	}
	
	function intContains(value) {
	  if (isInteger(value)) {
	    return value >= this.minValue && value <= this.maxValue;
	  } else if (value instanceof _pgLong2['default']) {
	    return value.greaterThanOrEqual(_pgLong2['default'].fromNumber(this.minValue)) && value.lessThanOrEqual(_pgLong2['default'].fromNumber(this.maxValue));
	  }
	  return false;
	}
	
	function longContains(value) {
	  if (!isInteger(value) && !_pgLong2['default'].isLong(value)) {
	    return false;
	  }
	  var v = value;
	  if (isInteger(value)) {
	    v = _pgLong2['default'].fromNumber(value, value >= 0);
	  }
	  return v.greaterThanOrEqual(_pgLong2['default'].MIN_VALUE) && v.lessThanOrEqual(_pgLong2['default'].MAX_UNSIGNED_VALUE);
	}
	
	var NumberType = (function () {
	  function NumberType(minValue, maxValue, containsFn) {
	    _classCallCheck(this, NumberType);
	
	    this.minValue = minValue;
	    this.maxValue = maxValue;
	    this.containsFn = containsFn;
	  }
	
	  _createClass(NumberType, [{
	    key: 'contains',
	    value: function contains(value) {
	      return this.containsFn ? this.containsFn.call(this, value) : intContains.call(this, value);
	    }
	  }]);
	
	  return NumberType;
	})();
	
	var FIXNUM = new NumberType(-32, 127),
	    BYTE = new NumberType(-128, 255),
	    SHORT = new NumberType(-32768, 65535),
	    INTEGER = new NumberType(-2147483648, 4294967295),
	    LONG = new NumberType(-9223372036854776000, 18446744073709548000, longContains),
	    FLOAT = new NumberType(-3.4028234e+38, 3.4028234e+38, isFloat),
	    DOUBLE = new NumberType(-1.7976931348623157e+308, 1.7976931348623157e+308, isDouble);
	
	function valueOf(n) {
	  return _lodash2['default'].find([FIXNUM, BYTE, SHORT, INTEGER, LONG, FLOAT, DOUBLE], function (type) {
	    return type.contains(n);
	  });
	}
	
	exports['default'] = { FIXNUM: FIXNUM, BYTE: BYTE, SHORT: SHORT, INTEGER: INTEGER, LONG: LONG, FLOAT: FLOAT, DOUBLE: DOUBLE, valueOf: valueOf, isInteger: isInteger, isFloat: isFloat, isDouble: isDouble, floatsEqual: floatsEqual };
	module.exports = exports['default'];

/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = { "default": __webpack_require__(20), __esModule: true };

/***/ },
/* 8 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	exports["default"] = function (obj) {
	  return obj && obj.__esModule ? obj : {
	    "default": obj
	  };
	};
	
	exports.__esModule = true;

/***/ },
/* 9 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_9__;

/***/ },
/* 10 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_10__;

/***/ },
/* 11 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_11__;

/***/ },
/* 12 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_12__;

/***/ },
/* 13 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_13__;

/***/ },
/* 14 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	var _Object$defineProperty = __webpack_require__(7)["default"];
	
	exports["default"] = (function () {
	  function defineProperties(target, props) {
	    for (var i = 0; i < props.length; i++) {
	      var descriptor = props[i];
	      descriptor.enumerable = descriptor.enumerable || false;
	      descriptor.configurable = true;
	      if ("value" in descriptor) descriptor.writable = true;
	
	      _Object$defineProperty(target, descriptor.key, descriptor);
	    }
	  }
	
	  return function (Constructor, protoProps, staticProps) {
	    if (protoProps) defineProperties(Constructor.prototype, protoProps);
	    if (staticProps) defineProperties(Constructor, staticProps);
	    return Constructor;
	  };
	})();
	
	exports.__esModule = true;

/***/ },
/* 15 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	exports["default"] = function (instance, Constructor) {
	  if (!(instance instanceof Constructor)) {
	    throw new TypeError("Cannot call a class as a function");
	  }
	};
	
	exports.__esModule = true;

/***/ },
/* 16 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	var _Object$create = __webpack_require__(21)["default"];
	
	exports["default"] = function (subClass, superClass) {
	  if (typeof superClass !== "function" && superClass !== null) {
	    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
	  }
	
	  subClass.prototype = _Object$create(superClass && superClass.prototype, {
	    constructor: {
	      value: subClass,
	      enumerable: false,
	      writable: true,
	      configurable: true
	    }
	  });
	  if (superClass) subClass.__proto__ = superClass;
	};
	
	exports.__esModule = true;

/***/ },
/* 17 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	var _Object$getOwnPropertyDescriptor = __webpack_require__(22)["default"];
	
	exports["default"] = function get(_x, _x2, _x3) {
	  var _again = true;
	
	  _function: while (_again) {
	    var object = _x,
	        property = _x2,
	        receiver = _x3;
	    desc = parent = getter = undefined;
	    _again = false;
	
	    var desc = _Object$getOwnPropertyDescriptor(object, property);
	
	    if (desc === undefined) {
	      var parent = Object.getPrototypeOf(object);
	
	      if (parent === null) {
	        return undefined;
	      } else {
	        _x = parent;
	        _x2 = property;
	        _x3 = receiver;
	        _again = true;
	        continue _function;
	      }
	    } else if ("value" in desc) {
	      return desc.value;
	    } else {
	      var getter = desc.get;
	
	      if (getter === undefined) {
	        return undefined;
	      }
	
	      return getter.call(receiver);
	    }
	  }
	};
	
	exports.__esModule = true;

/***/ },
/* 18 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = { "default": __webpack_require__(23), __esModule: true };

/***/ },
/* 19 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(Buffer) {/*!
	 * The buffer module from node.js, for the browser.
	 *
	 * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
	 * @license  MIT
	 */
	
	var base64 = __webpack_require__(34)
	var ieee754 = __webpack_require__(25)
	var isArray = __webpack_require__(26)
	
	exports.Buffer = Buffer
	exports.SlowBuffer = SlowBuffer
	exports.INSPECT_MAX_BYTES = 50
	Buffer.poolSize = 8192 // not used by this implementation
	
	var kMaxLength = 0x3fffffff
	var rootParent = {}
	
	/**
	 * If `Buffer.TYPED_ARRAY_SUPPORT`:
	 *   === true    Use Uint8Array implementation (fastest)
	 *   === false   Use Object implementation (most compatible, even IE6)
	 *
	 * Browsers that support typed arrays are IE 10+, Firefox 4+, Chrome 7+, Safari 5.1+,
	 * Opera 11.6+, iOS 4.2+.
	 *
	 * Note:
	 *
	 * - Implementation must support adding new properties to `Uint8Array` instances.
	 *   Firefox 4-29 lacked support, fixed in Firefox 30+.
	 *   See: https://bugzilla.mozilla.org/show_bug.cgi?id=695438.
	 *
	 *  - Chrome 9-10 is missing the `TypedArray.prototype.subarray` function.
	 *
	 *  - IE10 has a broken `TypedArray.prototype.subarray` function which returns arrays of
	 *    incorrect length in some situations.
	 *
	 * We detect these buggy browsers and set `Buffer.TYPED_ARRAY_SUPPORT` to `false` so they will
	 * get the Object implementation, which is slower but will work correctly.
	 */
	Buffer.TYPED_ARRAY_SUPPORT = (function () {
	  try {
	    var buf = new ArrayBuffer(0)
	    var arr = new Uint8Array(buf)
	    arr.foo = function () { return 42 }
	    return arr.foo() === 42 && // typed array instances can be augmented
	        typeof arr.subarray === 'function' && // chrome 9-10 lack `subarray`
	        new Uint8Array(1).subarray(1, 1).byteLength === 0 // ie10 has broken `subarray`
	  } catch (e) {
	    return false
	  }
	})()
	
	/**
	 * Class: Buffer
	 * =============
	 *
	 * The Buffer constructor returns instances of `Uint8Array` that are augmented
	 * with function properties for all the node `Buffer` API functions. We use
	 * `Uint8Array` so that square bracket notation works as expected -- it returns
	 * a single octet.
	 *
	 * By augmenting the instances, we can avoid modifying the `Uint8Array`
	 * prototype.
	 */
	function Buffer (arg) {
	  if (!(this instanceof Buffer)) {
	    // Avoid going through an ArgumentsAdaptorTrampoline in the common case.
	    if (arguments.length > 1) return new Buffer(arg, arguments[1])
	    return new Buffer(arg)
	  }
	
	  this.length = 0
	  this.parent = undefined
	
	  // Common case.
	  if (typeof arg === 'number') {
	    return fromNumber(this, arg)
	  }
	
	  // Slightly less common case.
	  if (typeof arg === 'string') {
	    return fromString(this, arg, arguments.length > 1 ? arguments[1] : 'utf8')
	  }
	
	  // Unusual.
	  return fromObject(this, arg)
	}
	
	function fromNumber (that, length) {
	  that = allocate(that, length < 0 ? 0 : checked(length) | 0)
	  if (!Buffer.TYPED_ARRAY_SUPPORT) {
	    for (var i = 0; i < length; i++) {
	      that[i] = 0
	    }
	  }
	  return that
	}
	
	function fromString (that, string, encoding) {
	  if (typeof encoding !== 'string' || encoding === '') encoding = 'utf8'
	
	  // Assumption: byteLength() return value is always < kMaxLength.
	  var length = byteLength(string, encoding) | 0
	  that = allocate(that, length)
	
	  that.write(string, encoding)
	  return that
	}
	
	function fromObject (that, object) {
	  if (Buffer.isBuffer(object)) return fromBuffer(that, object)
	
	  if (isArray(object)) return fromArray(that, object)
	
	  if (object == null) {
	    throw new TypeError('must start with number, buffer, array or string')
	  }
	
	  if (typeof ArrayBuffer !== 'undefined' && object.buffer instanceof ArrayBuffer) {
	    return fromTypedArray(that, object)
	  }
	
	  if (object.length) return fromArrayLike(that, object)
	
	  return fromJsonObject(that, object)
	}
	
	function fromBuffer (that, buffer) {
	  var length = checked(buffer.length) | 0
	  that = allocate(that, length)
	  buffer.copy(that, 0, 0, length)
	  return that
	}
	
	function fromArray (that, array) {
	  var length = checked(array.length) | 0
	  that = allocate(that, length)
	  for (var i = 0; i < length; i += 1) {
	    that[i] = array[i] & 255
	  }
	  return that
	}
	
	// Duplicate of fromArray() to keep fromArray() monomorphic.
	function fromTypedArray (that, array) {
	  var length = checked(array.length) | 0
	  that = allocate(that, length)
	  // Truncating the elements is probably not what people expect from typed
	  // arrays with BYTES_PER_ELEMENT > 1 but it's compatible with the behavior
	  // of the old Buffer constructor.
	  for (var i = 0; i < length; i += 1) {
	    that[i] = array[i] & 255
	  }
	  return that
	}
	
	function fromArrayLike (that, array) {
	  var length = checked(array.length) | 0
	  that = allocate(that, length)
	  for (var i = 0; i < length; i += 1) {
	    that[i] = array[i] & 255
	  }
	  return that
	}
	
	// Deserialize { type: 'Buffer', data: [1,2,3,...] } into a Buffer object.
	// Returns a zero-length buffer for inputs that don't conform to the spec.
	function fromJsonObject (that, object) {
	  var array
	  var length = 0
	
	  if (object.type === 'Buffer' && isArray(object.data)) {
	    array = object.data
	    length = checked(array.length) | 0
	  }
	  that = allocate(that, length)
	
	  for (var i = 0; i < length; i += 1) {
	    that[i] = array[i] & 255
	  }
	  return that
	}
	
	function allocate (that, length) {
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    // Return an augmented `Uint8Array` instance, for best performance
	    that = Buffer._augment(new Uint8Array(length))
	  } else {
	    // Fallback: Return an object instance of the Buffer class
	    that.length = length
	    that._isBuffer = true
	  }
	
	  var fromPool = length !== 0 && length <= Buffer.poolSize >>> 1
	  if (fromPool) that.parent = rootParent
	
	  return that
	}
	
	function checked (length) {
	  // Note: cannot use `length < kMaxLength` here because that fails when
	  // length is NaN (which is otherwise coerced to zero.)
	  if (length >= kMaxLength) {
	    throw new RangeError('Attempt to allocate Buffer larger than maximum ' +
	                         'size: 0x' + kMaxLength.toString(16) + ' bytes')
	  }
	  return length | 0
	}
	
	function SlowBuffer (subject, encoding) {
	  if (!(this instanceof SlowBuffer)) return new SlowBuffer(subject, encoding)
	
	  var buf = new Buffer(subject, encoding)
	  delete buf.parent
	  return buf
	}
	
	Buffer.isBuffer = function isBuffer (b) {
	  return !!(b != null && b._isBuffer)
	}
	
	Buffer.compare = function compare (a, b) {
	  if (!Buffer.isBuffer(a) || !Buffer.isBuffer(b)) {
	    throw new TypeError('Arguments must be Buffers')
	  }
	
	  if (a === b) return 0
	
	  var x = a.length
	  var y = b.length
	
	  var i = 0
	  var len = Math.min(x, y)
	  while (i < len) {
	    if (a[i] !== b[i]) break
	
	    ++i
	  }
	
	  if (i !== len) {
	    x = a[i]
	    y = b[i]
	  }
	
	  if (x < y) return -1
	  if (y < x) return 1
	  return 0
	}
	
	Buffer.isEncoding = function isEncoding (encoding) {
	  switch (String(encoding).toLowerCase()) {
	    case 'hex':
	    case 'utf8':
	    case 'utf-8':
	    case 'ascii':
	    case 'binary':
	    case 'base64':
	    case 'raw':
	    case 'ucs2':
	    case 'ucs-2':
	    case 'utf16le':
	    case 'utf-16le':
	      return true
	    default:
	      return false
	  }
	}
	
	Buffer.concat = function concat (list, length) {
	  if (!isArray(list)) throw new TypeError('list argument must be an Array of Buffers.')
	
	  if (list.length === 0) {
	    return new Buffer(0)
	  } else if (list.length === 1) {
	    return list[0]
	  }
	
	  var i
	  if (length === undefined) {
	    length = 0
	    for (i = 0; i < list.length; i++) {
	      length += list[i].length
	    }
	  }
	
	  var buf = new Buffer(length)
	  var pos = 0
	  for (i = 0; i < list.length; i++) {
	    var item = list[i]
	    item.copy(buf, pos)
	    pos += item.length
	  }
	  return buf
	}
	
	function byteLength (string, encoding) {
	  if (typeof string !== 'string') string = String(string)
	
	  if (string.length === 0) return 0
	
	  switch (encoding || 'utf8') {
	    case 'ascii':
	    case 'binary':
	    case 'raw':
	      return string.length
	    case 'ucs2':
	    case 'ucs-2':
	    case 'utf16le':
	    case 'utf-16le':
	      return string.length * 2
	    case 'hex':
	      return string.length >>> 1
	    case 'utf8':
	    case 'utf-8':
	      return utf8ToBytes(string).length
	    case 'base64':
	      return base64ToBytes(string).length
	    default:
	      return string.length
	  }
	}
	Buffer.byteLength = byteLength
	
	// pre-set for values that may exist in the future
	Buffer.prototype.length = undefined
	Buffer.prototype.parent = undefined
	
	// toString(encoding, start=0, end=buffer.length)
	Buffer.prototype.toString = function toString (encoding, start, end) {
	  var loweredCase = false
	
	  start = start | 0
	  end = end === undefined || end === Infinity ? this.length : end | 0
	
	  if (!encoding) encoding = 'utf8'
	  if (start < 0) start = 0
	  if (end > this.length) end = this.length
	  if (end <= start) return ''
	
	  while (true) {
	    switch (encoding) {
	      case 'hex':
	        return hexSlice(this, start, end)
	
	      case 'utf8':
	      case 'utf-8':
	        return utf8Slice(this, start, end)
	
	      case 'ascii':
	        return asciiSlice(this, start, end)
	
	      case 'binary':
	        return binarySlice(this, start, end)
	
	      case 'base64':
	        return base64Slice(this, start, end)
	
	      case 'ucs2':
	      case 'ucs-2':
	      case 'utf16le':
	      case 'utf-16le':
	        return utf16leSlice(this, start, end)
	
	      default:
	        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
	        encoding = (encoding + '').toLowerCase()
	        loweredCase = true
	    }
	  }
	}
	
	Buffer.prototype.equals = function equals (b) {
	  if (!Buffer.isBuffer(b)) throw new TypeError('Argument must be a Buffer')
	  if (this === b) return true
	  return Buffer.compare(this, b) === 0
	}
	
	Buffer.prototype.inspect = function inspect () {
	  var str = ''
	  var max = exports.INSPECT_MAX_BYTES
	  if (this.length > 0) {
	    str = this.toString('hex', 0, max).match(/.{2}/g).join(' ')
	    if (this.length > max) str += ' ... '
	  }
	  return '<Buffer ' + str + '>'
	}
	
	Buffer.prototype.compare = function compare (b) {
	  if (!Buffer.isBuffer(b)) throw new TypeError('Argument must be a Buffer')
	  if (this === b) return 0
	  return Buffer.compare(this, b)
	}
	
	Buffer.prototype.indexOf = function indexOf (val, byteOffset) {
	  if (byteOffset > 0x7fffffff) byteOffset = 0x7fffffff
	  else if (byteOffset < -0x80000000) byteOffset = -0x80000000
	  byteOffset >>= 0
	
	  if (this.length === 0) return -1
	  if (byteOffset >= this.length) return -1
	
	  // Negative offsets start from the end of the buffer
	  if (byteOffset < 0) byteOffset = Math.max(this.length + byteOffset, 0)
	
	  if (typeof val === 'string') {
	    if (val.length === 0) return -1 // special case: looking for empty string always fails
	    return String.prototype.indexOf.call(this, val, byteOffset)
	  }
	  if (Buffer.isBuffer(val)) {
	    return arrayIndexOf(this, val, byteOffset)
	  }
	  if (typeof val === 'number') {
	    if (Buffer.TYPED_ARRAY_SUPPORT && Uint8Array.prototype.indexOf === 'function') {
	      return Uint8Array.prototype.indexOf.call(this, val, byteOffset)
	    }
	    return arrayIndexOf(this, [ val ], byteOffset)
	  }
	
	  function arrayIndexOf (arr, val, byteOffset) {
	    var foundIndex = -1
	    for (var i = 0; byteOffset + i < arr.length; i++) {
	      if (arr[byteOffset + i] === val[foundIndex === -1 ? 0 : i - foundIndex]) {
	        if (foundIndex === -1) foundIndex = i
	        if (i - foundIndex + 1 === val.length) return byteOffset + foundIndex
	      } else {
	        foundIndex = -1
	      }
	    }
	    return -1
	  }
	
	  throw new TypeError('val must be string, number or Buffer')
	}
	
	// `get` will be removed in Node 0.13+
	Buffer.prototype.get = function get (offset) {
	  console.log('.get() is deprecated. Access using array indexes instead.')
	  return this.readUInt8(offset)
	}
	
	// `set` will be removed in Node 0.13+
	Buffer.prototype.set = function set (v, offset) {
	  console.log('.set() is deprecated. Access using array indexes instead.')
	  return this.writeUInt8(v, offset)
	}
	
	function hexWrite (buf, string, offset, length) {
	  offset = Number(offset) || 0
	  var remaining = buf.length - offset
	  if (!length) {
	    length = remaining
	  } else {
	    length = Number(length)
	    if (length > remaining) {
	      length = remaining
	    }
	  }
	
	  // must be an even number of digits
	  var strLen = string.length
	  if (strLen % 2 !== 0) throw new Error('Invalid hex string')
	
	  if (length > strLen / 2) {
	    length = strLen / 2
	  }
	  for (var i = 0; i < length; i++) {
	    var parsed = parseInt(string.substr(i * 2, 2), 16)
	    if (isNaN(parsed)) throw new Error('Invalid hex string')
	    buf[offset + i] = parsed
	  }
	  return i
	}
	
	function utf8Write (buf, string, offset, length) {
	  return blitBuffer(utf8ToBytes(string, buf.length - offset), buf, offset, length)
	}
	
	function asciiWrite (buf, string, offset, length) {
	  return blitBuffer(asciiToBytes(string), buf, offset, length)
	}
	
	function binaryWrite (buf, string, offset, length) {
	  return asciiWrite(buf, string, offset, length)
	}
	
	function base64Write (buf, string, offset, length) {
	  return blitBuffer(base64ToBytes(string), buf, offset, length)
	}
	
	function ucs2Write (buf, string, offset, length) {
	  return blitBuffer(utf16leToBytes(string, buf.length - offset), buf, offset, length)
	}
	
	Buffer.prototype.write = function write (string, offset, length, encoding) {
	  // Buffer#write(string)
	  if (offset === undefined) {
	    encoding = 'utf8'
	    length = this.length
	    offset = 0
	  // Buffer#write(string, encoding)
	  } else if (length === undefined && typeof offset === 'string') {
	    encoding = offset
	    length = this.length
	    offset = 0
	  // Buffer#write(string, offset[, length][, encoding])
	  } else if (isFinite(offset)) {
	    offset = offset | 0
	    if (isFinite(length)) {
	      length = length | 0
	      if (encoding === undefined) encoding = 'utf8'
	    } else {
	      encoding = length
	      length = undefined
	    }
	  // legacy write(string, encoding, offset, length) - remove in v0.13
	  } else {
	    var swap = encoding
	    encoding = offset
	    offset = length | 0
	    length = swap
	  }
	
	  var remaining = this.length - offset
	  if (length === undefined || length > remaining) length = remaining
	
	  if ((string.length > 0 && (length < 0 || offset < 0)) || offset > this.length) {
	    throw new RangeError('attempt to write outside buffer bounds')
	  }
	
	  if (!encoding) encoding = 'utf8'
	
	  var loweredCase = false
	  for (;;) {
	    switch (encoding) {
	      case 'hex':
	        return hexWrite(this, string, offset, length)
	
	      case 'utf8':
	      case 'utf-8':
	        return utf8Write(this, string, offset, length)
	
	      case 'ascii':
	        return asciiWrite(this, string, offset, length)
	
	      case 'binary':
	        return binaryWrite(this, string, offset, length)
	
	      case 'base64':
	        // Warning: maxLength not taken into account in base64Write
	        return base64Write(this, string, offset, length)
	
	      case 'ucs2':
	      case 'ucs-2':
	      case 'utf16le':
	      case 'utf-16le':
	        return ucs2Write(this, string, offset, length)
	
	      default:
	        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
	        encoding = ('' + encoding).toLowerCase()
	        loweredCase = true
	    }
	  }
	}
	
	Buffer.prototype.toJSON = function toJSON () {
	  return {
	    type: 'Buffer',
	    data: Array.prototype.slice.call(this._arr || this, 0)
	  }
	}
	
	function base64Slice (buf, start, end) {
	  if (start === 0 && end === buf.length) {
	    return base64.fromByteArray(buf)
	  } else {
	    return base64.fromByteArray(buf.slice(start, end))
	  }
	}
	
	function utf8Slice (buf, start, end) {
	  var res = ''
	  var tmp = ''
	  end = Math.min(buf.length, end)
	
	  for (var i = start; i < end; i++) {
	    if (buf[i] <= 0x7F) {
	      res += decodeUtf8Char(tmp) + String.fromCharCode(buf[i])
	      tmp = ''
	    } else {
	      tmp += '%' + buf[i].toString(16)
	    }
	  }
	
	  return res + decodeUtf8Char(tmp)
	}
	
	function asciiSlice (buf, start, end) {
	  var ret = ''
	  end = Math.min(buf.length, end)
	
	  for (var i = start; i < end; i++) {
	    ret += String.fromCharCode(buf[i] & 0x7F)
	  }
	  return ret
	}
	
	function binarySlice (buf, start, end) {
	  var ret = ''
	  end = Math.min(buf.length, end)
	
	  for (var i = start; i < end; i++) {
	    ret += String.fromCharCode(buf[i])
	  }
	  return ret
	}
	
	function hexSlice (buf, start, end) {
	  var len = buf.length
	
	  if (!start || start < 0) start = 0
	  if (!end || end < 0 || end > len) end = len
	
	  var out = ''
	  for (var i = start; i < end; i++) {
	    out += toHex(buf[i])
	  }
	  return out
	}
	
	function utf16leSlice (buf, start, end) {
	  var bytes = buf.slice(start, end)
	  var res = ''
	  for (var i = 0; i < bytes.length; i += 2) {
	    res += String.fromCharCode(bytes[i] + bytes[i + 1] * 256)
	  }
	  return res
	}
	
	Buffer.prototype.slice = function slice (start, end) {
	  var len = this.length
	  start = ~~start
	  end = end === undefined ? len : ~~end
	
	  if (start < 0) {
	    start += len
	    if (start < 0) start = 0
	  } else if (start > len) {
	    start = len
	  }
	
	  if (end < 0) {
	    end += len
	    if (end < 0) end = 0
	  } else if (end > len) {
	    end = len
	  }
	
	  if (end < start) end = start
	
	  var newBuf
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    newBuf = Buffer._augment(this.subarray(start, end))
	  } else {
	    var sliceLen = end - start
	    newBuf = new Buffer(sliceLen, undefined)
	    for (var i = 0; i < sliceLen; i++) {
	      newBuf[i] = this[i + start]
	    }
	  }
	
	  if (newBuf.length) newBuf.parent = this.parent || this
	
	  return newBuf
	}
	
	/*
	 * Need to make sure that buffer isn't trying to write out of bounds.
	 */
	function checkOffset (offset, ext, length) {
	  if ((offset % 1) !== 0 || offset < 0) throw new RangeError('offset is not uint')
	  if (offset + ext > length) throw new RangeError('Trying to access beyond buffer length')
	}
	
	Buffer.prototype.readUIntLE = function readUIntLE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkOffset(offset, byteLength, this.length)
	
	  var val = this[offset]
	  var mul = 1
	  var i = 0
	  while (++i < byteLength && (mul *= 0x100)) {
	    val += this[offset + i] * mul
	  }
	
	  return val
	}
	
	Buffer.prototype.readUIntBE = function readUIntBE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) {
	    checkOffset(offset, byteLength, this.length)
	  }
	
	  var val = this[offset + --byteLength]
	  var mul = 1
	  while (byteLength > 0 && (mul *= 0x100)) {
	    val += this[offset + --byteLength] * mul
	  }
	
	  return val
	}
	
	Buffer.prototype.readUInt8 = function readUInt8 (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 1, this.length)
	  return this[offset]
	}
	
	Buffer.prototype.readUInt16LE = function readUInt16LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  return this[offset] | (this[offset + 1] << 8)
	}
	
	Buffer.prototype.readUInt16BE = function readUInt16BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  return (this[offset] << 8) | this[offset + 1]
	}
	
	Buffer.prototype.readUInt32LE = function readUInt32LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)
	
	  return ((this[offset]) |
	      (this[offset + 1] << 8) |
	      (this[offset + 2] << 16)) +
	      (this[offset + 3] * 0x1000000)
	}
	
	Buffer.prototype.readUInt32BE = function readUInt32BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)
	
	  return (this[offset] * 0x1000000) +
	    ((this[offset + 1] << 16) |
	    (this[offset + 2] << 8) |
	    this[offset + 3])
	}
	
	Buffer.prototype.readIntLE = function readIntLE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkOffset(offset, byteLength, this.length)
	
	  var val = this[offset]
	  var mul = 1
	  var i = 0
	  while (++i < byteLength && (mul *= 0x100)) {
	    val += this[offset + i] * mul
	  }
	  mul *= 0x80
	
	  if (val >= mul) val -= Math.pow(2, 8 * byteLength)
	
	  return val
	}
	
	Buffer.prototype.readIntBE = function readIntBE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkOffset(offset, byteLength, this.length)
	
	  var i = byteLength
	  var mul = 1
	  var val = this[offset + --i]
	  while (i > 0 && (mul *= 0x100)) {
	    val += this[offset + --i] * mul
	  }
	  mul *= 0x80
	
	  if (val >= mul) val -= Math.pow(2, 8 * byteLength)
	
	  return val
	}
	
	Buffer.prototype.readInt8 = function readInt8 (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 1, this.length)
	  if (!(this[offset] & 0x80)) return (this[offset])
	  return ((0xff - this[offset] + 1) * -1)
	}
	
	Buffer.prototype.readInt16LE = function readInt16LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  var val = this[offset] | (this[offset + 1] << 8)
	  return (val & 0x8000) ? val | 0xFFFF0000 : val
	}
	
	Buffer.prototype.readInt16BE = function readInt16BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  var val = this[offset + 1] | (this[offset] << 8)
	  return (val & 0x8000) ? val | 0xFFFF0000 : val
	}
	
	Buffer.prototype.readInt32LE = function readInt32LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)
	
	  return (this[offset]) |
	    (this[offset + 1] << 8) |
	    (this[offset + 2] << 16) |
	    (this[offset + 3] << 24)
	}
	
	Buffer.prototype.readInt32BE = function readInt32BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)
	
	  return (this[offset] << 24) |
	    (this[offset + 1] << 16) |
	    (this[offset + 2] << 8) |
	    (this[offset + 3])
	}
	
	Buffer.prototype.readFloatLE = function readFloatLE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)
	  return ieee754.read(this, offset, true, 23, 4)
	}
	
	Buffer.prototype.readFloatBE = function readFloatBE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)
	  return ieee754.read(this, offset, false, 23, 4)
	}
	
	Buffer.prototype.readDoubleLE = function readDoubleLE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 8, this.length)
	  return ieee754.read(this, offset, true, 52, 8)
	}
	
	Buffer.prototype.readDoubleBE = function readDoubleBE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 8, this.length)
	  return ieee754.read(this, offset, false, 52, 8)
	}
	
	function checkInt (buf, value, offset, ext, max, min) {
	  if (!Buffer.isBuffer(buf)) throw new TypeError('buffer must be a Buffer instance')
	  if (value > max || value < min) throw new RangeError('value is out of bounds')
	  if (offset + ext > buf.length) throw new RangeError('index out of range')
	}
	
	Buffer.prototype.writeUIntLE = function writeUIntLE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkInt(this, value, offset, byteLength, Math.pow(2, 8 * byteLength), 0)
	
	  var mul = 1
	  var i = 0
	  this[offset] = value & 0xFF
	  while (++i < byteLength && (mul *= 0x100)) {
	    this[offset + i] = (value / mul) & 0xFF
	  }
	
	  return offset + byteLength
	}
	
	Buffer.prototype.writeUIntBE = function writeUIntBE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkInt(this, value, offset, byteLength, Math.pow(2, 8 * byteLength), 0)
	
	  var i = byteLength - 1
	  var mul = 1
	  this[offset + i] = value & 0xFF
	  while (--i >= 0 && (mul *= 0x100)) {
	    this[offset + i] = (value / mul) & 0xFF
	  }
	
	  return offset + byteLength
	}
	
	Buffer.prototype.writeUInt8 = function writeUInt8 (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 1, 0xff, 0)
	  if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value)
	  this[offset] = value
	  return offset + 1
	}
	
	function objectWriteUInt16 (buf, value, offset, littleEndian) {
	  if (value < 0) value = 0xffff + value + 1
	  for (var i = 0, j = Math.min(buf.length - offset, 2); i < j; i++) {
	    buf[offset + i] = (value & (0xff << (8 * (littleEndian ? i : 1 - i)))) >>>
	      (littleEndian ? i : 1 - i) * 8
	  }
	}
	
	Buffer.prototype.writeUInt16LE = function writeUInt16LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = value
	    this[offset + 1] = (value >>> 8)
	  } else {
	    objectWriteUInt16(this, value, offset, true)
	  }
	  return offset + 2
	}
	
	Buffer.prototype.writeUInt16BE = function writeUInt16BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 8)
	    this[offset + 1] = value
	  } else {
	    objectWriteUInt16(this, value, offset, false)
	  }
	  return offset + 2
	}
	
	function objectWriteUInt32 (buf, value, offset, littleEndian) {
	  if (value < 0) value = 0xffffffff + value + 1
	  for (var i = 0, j = Math.min(buf.length - offset, 4); i < j; i++) {
	    buf[offset + i] = (value >>> (littleEndian ? i : 3 - i) * 8) & 0xff
	  }
	}
	
	Buffer.prototype.writeUInt32LE = function writeUInt32LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset + 3] = (value >>> 24)
	    this[offset + 2] = (value >>> 16)
	    this[offset + 1] = (value >>> 8)
	    this[offset] = value
	  } else {
	    objectWriteUInt32(this, value, offset, true)
	  }
	  return offset + 4
	}
	
	Buffer.prototype.writeUInt32BE = function writeUInt32BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 24)
	    this[offset + 1] = (value >>> 16)
	    this[offset + 2] = (value >>> 8)
	    this[offset + 3] = value
	  } else {
	    objectWriteUInt32(this, value, offset, false)
	  }
	  return offset + 4
	}
	
	Buffer.prototype.writeIntLE = function writeIntLE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) {
	    var limit = Math.pow(2, 8 * byteLength - 1)
	
	    checkInt(this, value, offset, byteLength, limit - 1, -limit)
	  }
	
	  var i = 0
	  var mul = 1
	  var sub = value < 0 ? 1 : 0
	  this[offset] = value & 0xFF
	  while (++i < byteLength && (mul *= 0x100)) {
	    this[offset + i] = ((value / mul) >> 0) - sub & 0xFF
	  }
	
	  return offset + byteLength
	}
	
	Buffer.prototype.writeIntBE = function writeIntBE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) {
	    var limit = Math.pow(2, 8 * byteLength - 1)
	
	    checkInt(this, value, offset, byteLength, limit - 1, -limit)
	  }
	
	  var i = byteLength - 1
	  var mul = 1
	  var sub = value < 0 ? 1 : 0
	  this[offset + i] = value & 0xFF
	  while (--i >= 0 && (mul *= 0x100)) {
	    this[offset + i] = ((value / mul) >> 0) - sub & 0xFF
	  }
	
	  return offset + byteLength
	}
	
	Buffer.prototype.writeInt8 = function writeInt8 (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 1, 0x7f, -0x80)
	  if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value)
	  if (value < 0) value = 0xff + value + 1
	  this[offset] = value
	  return offset + 1
	}
	
	Buffer.prototype.writeInt16LE = function writeInt16LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = value
	    this[offset + 1] = (value >>> 8)
	  } else {
	    objectWriteUInt16(this, value, offset, true)
	  }
	  return offset + 2
	}
	
	Buffer.prototype.writeInt16BE = function writeInt16BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 8)
	    this[offset + 1] = value
	  } else {
	    objectWriteUInt16(this, value, offset, false)
	  }
	  return offset + 2
	}
	
	Buffer.prototype.writeInt32LE = function writeInt32LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = value
	    this[offset + 1] = (value >>> 8)
	    this[offset + 2] = (value >>> 16)
	    this[offset + 3] = (value >>> 24)
	  } else {
	    objectWriteUInt32(this, value, offset, true)
	  }
	  return offset + 4
	}
	
	Buffer.prototype.writeInt32BE = function writeInt32BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000)
	  if (value < 0) value = 0xffffffff + value + 1
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 24)
	    this[offset + 1] = (value >>> 16)
	    this[offset + 2] = (value >>> 8)
	    this[offset + 3] = value
	  } else {
	    objectWriteUInt32(this, value, offset, false)
	  }
	  return offset + 4
	}
	
	function checkIEEE754 (buf, value, offset, ext, max, min) {
	  if (value > max || value < min) throw new RangeError('value is out of bounds')
	  if (offset + ext > buf.length) throw new RangeError('index out of range')
	  if (offset < 0) throw new RangeError('index out of range')
	}
	
	function writeFloat (buf, value, offset, littleEndian, noAssert) {
	  if (!noAssert) {
	    checkIEEE754(buf, value, offset, 4, 3.4028234663852886e+38, -3.4028234663852886e+38)
	  }
	  ieee754.write(buf, value, offset, littleEndian, 23, 4)
	  return offset + 4
	}
	
	Buffer.prototype.writeFloatLE = function writeFloatLE (value, offset, noAssert) {
	  return writeFloat(this, value, offset, true, noAssert)
	}
	
	Buffer.prototype.writeFloatBE = function writeFloatBE (value, offset, noAssert) {
	  return writeFloat(this, value, offset, false, noAssert)
	}
	
	function writeDouble (buf, value, offset, littleEndian, noAssert) {
	  if (!noAssert) {
	    checkIEEE754(buf, value, offset, 8, 1.7976931348623157E+308, -1.7976931348623157E+308)
	  }
	  ieee754.write(buf, value, offset, littleEndian, 52, 8)
	  return offset + 8
	}
	
	Buffer.prototype.writeDoubleLE = function writeDoubleLE (value, offset, noAssert) {
	  return writeDouble(this, value, offset, true, noAssert)
	}
	
	Buffer.prototype.writeDoubleBE = function writeDoubleBE (value, offset, noAssert) {
	  return writeDouble(this, value, offset, false, noAssert)
	}
	
	// copy(targetBuffer, targetStart=0, sourceStart=0, sourceEnd=buffer.length)
	Buffer.prototype.copy = function copy (target, targetStart, start, end) {
	  if (!start) start = 0
	  if (!end && end !== 0) end = this.length
	  if (targetStart >= target.length) targetStart = target.length
	  if (!targetStart) targetStart = 0
	  if (end > 0 && end < start) end = start
	
	  // Copy 0 bytes; we're done
	  if (end === start) return 0
	  if (target.length === 0 || this.length === 0) return 0
	
	  // Fatal error conditions
	  if (targetStart < 0) {
	    throw new RangeError('targetStart out of bounds')
	  }
	  if (start < 0 || start >= this.length) throw new RangeError('sourceStart out of bounds')
	  if (end < 0) throw new RangeError('sourceEnd out of bounds')
	
	  // Are we oob?
	  if (end > this.length) end = this.length
	  if (target.length - targetStart < end - start) {
	    end = target.length - targetStart + start
	  }
	
	  var len = end - start
	
	  if (len < 1000 || !Buffer.TYPED_ARRAY_SUPPORT) {
	    for (var i = 0; i < len; i++) {
	      target[i + targetStart] = this[i + start]
	    }
	  } else {
	    target._set(this.subarray(start, start + len), targetStart)
	  }
	
	  return len
	}
	
	// fill(value, start=0, end=buffer.length)
	Buffer.prototype.fill = function fill (value, start, end) {
	  if (!value) value = 0
	  if (!start) start = 0
	  if (!end) end = this.length
	
	  if (end < start) throw new RangeError('end < start')
	
	  // Fill 0 bytes; we're done
	  if (end === start) return
	  if (this.length === 0) return
	
	  if (start < 0 || start >= this.length) throw new RangeError('start out of bounds')
	  if (end < 0 || end > this.length) throw new RangeError('end out of bounds')
	
	  var i
	  if (typeof value === 'number') {
	    for (i = start; i < end; i++) {
	      this[i] = value
	    }
	  } else {
	    var bytes = utf8ToBytes(value.toString())
	    var len = bytes.length
	    for (i = start; i < end; i++) {
	      this[i] = bytes[i % len]
	    }
	  }
	
	  return this
	}
	
	/**
	 * Creates a new `ArrayBuffer` with the *copied* memory of the buffer instance.
	 * Added in Node 0.12. Only available in browsers that support ArrayBuffer.
	 */
	Buffer.prototype.toArrayBuffer = function toArrayBuffer () {
	  if (typeof Uint8Array !== 'undefined') {
	    if (Buffer.TYPED_ARRAY_SUPPORT) {
	      return (new Buffer(this)).buffer
	    } else {
	      var buf = new Uint8Array(this.length)
	      for (var i = 0, len = buf.length; i < len; i += 1) {
	        buf[i] = this[i]
	      }
	      return buf.buffer
	    }
	  } else {
	    throw new TypeError('Buffer.toArrayBuffer not supported in this browser')
	  }
	}
	
	// HELPER FUNCTIONS
	// ================
	
	var BP = Buffer.prototype
	
	/**
	 * Augment a Uint8Array *instance* (not the Uint8Array class!) with Buffer methods
	 */
	Buffer._augment = function _augment (arr) {
	  arr.constructor = Buffer
	  arr._isBuffer = true
	
	  // save reference to original Uint8Array set method before overwriting
	  arr._set = arr.set
	
	  // deprecated, will be removed in node 0.13+
	  arr.get = BP.get
	  arr.set = BP.set
	
	  arr.write = BP.write
	  arr.toString = BP.toString
	  arr.toLocaleString = BP.toString
	  arr.toJSON = BP.toJSON
	  arr.equals = BP.equals
	  arr.compare = BP.compare
	  arr.indexOf = BP.indexOf
	  arr.copy = BP.copy
	  arr.slice = BP.slice
	  arr.readUIntLE = BP.readUIntLE
	  arr.readUIntBE = BP.readUIntBE
	  arr.readUInt8 = BP.readUInt8
	  arr.readUInt16LE = BP.readUInt16LE
	  arr.readUInt16BE = BP.readUInt16BE
	  arr.readUInt32LE = BP.readUInt32LE
	  arr.readUInt32BE = BP.readUInt32BE
	  arr.readIntLE = BP.readIntLE
	  arr.readIntBE = BP.readIntBE
	  arr.readInt8 = BP.readInt8
	  arr.readInt16LE = BP.readInt16LE
	  arr.readInt16BE = BP.readInt16BE
	  arr.readInt32LE = BP.readInt32LE
	  arr.readInt32BE = BP.readInt32BE
	  arr.readFloatLE = BP.readFloatLE
	  arr.readFloatBE = BP.readFloatBE
	  arr.readDoubleLE = BP.readDoubleLE
	  arr.readDoubleBE = BP.readDoubleBE
	  arr.writeUInt8 = BP.writeUInt8
	  arr.writeUIntLE = BP.writeUIntLE
	  arr.writeUIntBE = BP.writeUIntBE
	  arr.writeUInt16LE = BP.writeUInt16LE
	  arr.writeUInt16BE = BP.writeUInt16BE
	  arr.writeUInt32LE = BP.writeUInt32LE
	  arr.writeUInt32BE = BP.writeUInt32BE
	  arr.writeIntLE = BP.writeIntLE
	  arr.writeIntBE = BP.writeIntBE
	  arr.writeInt8 = BP.writeInt8
	  arr.writeInt16LE = BP.writeInt16LE
	  arr.writeInt16BE = BP.writeInt16BE
	  arr.writeInt32LE = BP.writeInt32LE
	  arr.writeInt32BE = BP.writeInt32BE
	  arr.writeFloatLE = BP.writeFloatLE
	  arr.writeFloatBE = BP.writeFloatBE
	  arr.writeDoubleLE = BP.writeDoubleLE
	  arr.writeDoubleBE = BP.writeDoubleBE
	  arr.fill = BP.fill
	  arr.inspect = BP.inspect
	  arr.toArrayBuffer = BP.toArrayBuffer
	
	  return arr
	}
	
	var INVALID_BASE64_RE = /[^+\/0-9A-z\-]/g
	
	function base64clean (str) {
	  // Node strips out invalid characters like \n and \t from the string, base64-js does not
	  str = stringtrim(str).replace(INVALID_BASE64_RE, '')
	  // Node converts strings with length < 2 to ''
	  if (str.length < 2) return ''
	  // Node allows for non-padded base64 strings (missing trailing ===), base64-js does not
	  while (str.length % 4 !== 0) {
	    str = str + '='
	  }
	  return str
	}
	
	function stringtrim (str) {
	  if (str.trim) return str.trim()
	  return str.replace(/^\s+|\s+$/g, '')
	}
	
	function toHex (n) {
	  if (n < 16) return '0' + n.toString(16)
	  return n.toString(16)
	}
	
	function utf8ToBytes (string, units) {
	  units = units || Infinity
	  var codePoint
	  var length = string.length
	  var leadSurrogate = null
	  var bytes = []
	  var i = 0
	
	  for (; i < length; i++) {
	    codePoint = string.charCodeAt(i)
	
	    // is surrogate component
	    if (codePoint > 0xD7FF && codePoint < 0xE000) {
	      // last char was a lead
	      if (leadSurrogate) {
	        // 2 leads in a row
	        if (codePoint < 0xDC00) {
	          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	          leadSurrogate = codePoint
	          continue
	        } else {
	          // valid surrogate pair
	          codePoint = leadSurrogate - 0xD800 << 10 | codePoint - 0xDC00 | 0x10000
	          leadSurrogate = null
	        }
	      } else {
	        // no lead yet
	
	        if (codePoint > 0xDBFF) {
	          // unexpected trail
	          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	          continue
	        } else if (i + 1 === length) {
	          // unpaired lead
	          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	          continue
	        } else {
	          // valid lead
	          leadSurrogate = codePoint
	          continue
	        }
	      }
	    } else if (leadSurrogate) {
	      // valid bmp char, but last char was a lead
	      if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	      leadSurrogate = null
	    }
	
	    // encode utf8
	    if (codePoint < 0x80) {
	      if ((units -= 1) < 0) break
	      bytes.push(codePoint)
	    } else if (codePoint < 0x800) {
	      if ((units -= 2) < 0) break
	      bytes.push(
	        codePoint >> 0x6 | 0xC0,
	        codePoint & 0x3F | 0x80
	      )
	    } else if (codePoint < 0x10000) {
	      if ((units -= 3) < 0) break
	      bytes.push(
	        codePoint >> 0xC | 0xE0,
	        codePoint >> 0x6 & 0x3F | 0x80,
	        codePoint & 0x3F | 0x80
	      )
	    } else if (codePoint < 0x200000) {
	      if ((units -= 4) < 0) break
	      bytes.push(
	        codePoint >> 0x12 | 0xF0,
	        codePoint >> 0xC & 0x3F | 0x80,
	        codePoint >> 0x6 & 0x3F | 0x80,
	        codePoint & 0x3F | 0x80
	      )
	    } else {
	      throw new Error('Invalid code point')
	    }
	  }
	
	  return bytes
	}
	
	function asciiToBytes (str) {
	  var byteArray = []
	  for (var i = 0; i < str.length; i++) {
	    // Node's code seems to be doing this and not & 0x7F..
	    byteArray.push(str.charCodeAt(i) & 0xFF)
	  }
	  return byteArray
	}
	
	function utf16leToBytes (str, units) {
	  var c, hi, lo
	  var byteArray = []
	  for (var i = 0; i < str.length; i++) {
	    if ((units -= 2) < 0) break
	
	    c = str.charCodeAt(i)
	    hi = c >> 8
	    lo = c % 256
	    byteArray.push(lo)
	    byteArray.push(hi)
	  }
	
	  return byteArray
	}
	
	function base64ToBytes (str) {
	  return base64.toByteArray(base64clean(str))
	}
	
	function blitBuffer (src, dst, offset, length) {
	  for (var i = 0; i < length; i++) {
	    if ((i + offset >= dst.length) || (i >= src.length)) break
	    dst[i + offset] = src[i]
	  }
	  return i
	}
	
	function decodeUtf8Char (str) {
	  try {
	    return decodeURIComponent(str)
	  } catch (err) {
	    return String.fromCharCode(0xFFFD) // UTF 8 invalid char
	  }
	}
	
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(19).Buffer))

/***/ },
/* 20 */
/***/ function(module, exports, __webpack_require__) {

	var $ = __webpack_require__(24);
	module.exports = function defineProperty(it, key, desc){
	  return $.setDesc(it, key, desc);
	};

/***/ },
/* 21 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = { "default": __webpack_require__(27), __esModule: true };

/***/ },
/* 22 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = { "default": __webpack_require__(33), __esModule: true };

/***/ },
/* 23 */
/***/ function(module, exports, __webpack_require__) {

	__webpack_require__(28);
	__webpack_require__(29);
	__webpack_require__(30);
	__webpack_require__(31);
	__webpack_require__(32);
	module.exports = __webpack_require__(24).core.Map;

/***/ },
/* 24 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	var global = typeof self != 'undefined' ? self : Function('return this')()
	  , core   = {}
	  , defineProperty = Object.defineProperty
	  , hasOwnProperty = {}.hasOwnProperty
	  , ceil  = Math.ceil
	  , floor = Math.floor
	  , max   = Math.max
	  , min   = Math.min;
	// The engine works fine with descriptors? Thank's IE8 for his funny defineProperty.
	var DESC = !!function(){
	  try {
	    return defineProperty({}, 'a', {get: function(){ return 2; }}).a == 2;
	  } catch(e){ /* empty */ }
	}();
	var hide = createDefiner(1);
	// 7.1.4 ToInteger
	function toInteger(it){
	  return isNaN(it = +it) ? 0 : (it > 0 ? floor : ceil)(it);
	}
	function desc(bitmap, value){
	  return {
	    enumerable  : !(bitmap & 1),
	    configurable: !(bitmap & 2),
	    writable    : !(bitmap & 4),
	    value       : value
	  };
	}
	function simpleSet(object, key, value){
	  object[key] = value;
	  return object;
	}
	function createDefiner(bitmap){
	  return DESC ? function(object, key, value){
	    return $.setDesc(object, key, desc(bitmap, value));
	  } : simpleSet;
	}
	
	function isObject(it){
	  return it !== null && (typeof it == 'object' || typeof it == 'function');
	}
	function isFunction(it){
	  return typeof it == 'function';
	}
	function assertDefined(it){
	  if(it == undefined)throw TypeError("Can't call method on  " + it);
	  return it;
	}
	
	var $ = module.exports = __webpack_require__(35)({
	  g: global,
	  core: core,
	  html: global.document && document.documentElement,
	  // http://jsperf.com/core-js-isobject
	  isObject:   isObject,
	  isFunction: isFunction,
	  it: function(it){
	    return it;
	  },
	  that: function(){
	    return this;
	  },
	  // 7.1.4 ToInteger
	  toInteger: toInteger,
	  // 7.1.15 ToLength
	  toLength: function(it){
	    return it > 0 ? min(toInteger(it), 0x1fffffffffffff) : 0; // pow(2, 53) - 1 == 9007199254740991
	  },
	  toIndex: function(index, length){
	    index = toInteger(index);
	    return index < 0 ? max(index + length, 0) : min(index, length);
	  },
	  has: function(it, key){
	    return hasOwnProperty.call(it, key);
	  },
	  create:     Object.create,
	  getProto:   Object.getPrototypeOf,
	  DESC:       DESC,
	  desc:       desc,
	  getDesc:    Object.getOwnPropertyDescriptor,
	  setDesc:    defineProperty,
	  setDescs:   Object.defineProperties,
	  getKeys:    Object.keys,
	  getNames:   Object.getOwnPropertyNames,
	  getSymbols: Object.getOwnPropertySymbols,
	  assertDefined: assertDefined,
	  // Dummy, fix for not array-like ES3 string in es5 module
	  ES5Object: Object,
	  toObject: function(it){
	    return $.ES5Object(assertDefined(it));
	  },
	  hide: hide,
	  def: createDefiner(0),
	  set: global.Symbol ? simpleSet : hide,
	  each: [].forEach
	});
	/* eslint-disable no-undef */
	if(typeof __e != 'undefined')__e = core;
	if(typeof __g != 'undefined')__g = global;

/***/ },
/* 25 */
/***/ function(module, exports, __webpack_require__) {

	exports.read = function (buffer, offset, isLE, mLen, nBytes) {
	  var e, m,
	      eLen = nBytes * 8 - mLen - 1,
	      eMax = (1 << eLen) - 1,
	      eBias = eMax >> 1,
	      nBits = -7,
	      i = isLE ? (nBytes - 1) : 0,
	      d = isLE ? -1 : 1,
	      s = buffer[offset + i]
	
	  i += d
	
	  e = s & ((1 << (-nBits)) - 1)
	  s >>= (-nBits)
	  nBits += eLen
	  for (; nBits > 0; e = e * 256 + buffer[offset + i], i += d, nBits -= 8) {}
	
	  m = e & ((1 << (-nBits)) - 1)
	  e >>= (-nBits)
	  nBits += mLen
	  for (; nBits > 0; m = m * 256 + buffer[offset + i], i += d, nBits -= 8) {}
	
	  if (e === 0) {
	    e = 1 - eBias
	  } else if (e === eMax) {
	    return m ? NaN : ((s ? -1 : 1) * Infinity)
	  } else {
	    m = m + Math.pow(2, mLen)
	    e = e - eBias
	  }
	  return (s ? -1 : 1) * m * Math.pow(2, e - mLen)
	}
	
	exports.write = function (buffer, value, offset, isLE, mLen, nBytes) {
	  var e, m, c,
	      eLen = nBytes * 8 - mLen - 1,
	      eMax = (1 << eLen) - 1,
	      eBias = eMax >> 1,
	      rt = (mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0),
	      i = isLE ? 0 : (nBytes - 1),
	      d = isLE ? 1 : -1,
	      s = value < 0 || (value === 0 && 1 / value < 0) ? 1 : 0
	
	  value = Math.abs(value)
	
	  if (isNaN(value) || value === Infinity) {
	    m = isNaN(value) ? 1 : 0
	    e = eMax
	  } else {
	    e = Math.floor(Math.log(value) / Math.LN2)
	    if (value * (c = Math.pow(2, -e)) < 1) {
	      e--
	      c *= 2
	    }
	    if (e + eBias >= 1) {
	      value += rt / c
	    } else {
	      value += rt * Math.pow(2, 1 - eBias)
	    }
	    if (value * c >= 2) {
	      e++
	      c /= 2
	    }
	
	    if (e + eBias >= eMax) {
	      m = 0
	      e = eMax
	    } else if (e + eBias >= 1) {
	      m = (value * c - 1) * Math.pow(2, mLen)
	      e = e + eBias
	    } else {
	      m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen)
	      e = 0
	    }
	  }
	
	  for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}
	
	  e = (e << mLen) | m
	  eLen += mLen
	  for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}
	
	  buffer[offset + i - d] |= s * 128
	}


/***/ },
/* 26 */
/***/ function(module, exports, __webpack_require__) {

	
	/**
	 * isArray
	 */
	
	var isArray = Array.isArray;
	
	/**
	 * toString
	 */
	
	var str = Object.prototype.toString;
	
	/**
	 * Whether or not the given `val`
	 * is an array.
	 *
	 * example:
	 *
	 *        isArray([]);
	 *        // > true
	 *        isArray(arguments);
	 *        // > false
	 *        isArray('');
	 *        // > false
	 *
	 * @param {mixed} val
	 * @return {bool}
	 */
	
	module.exports = isArray || function (val) {
	  return !! val && '[object Array]' == str.call(val);
	};


/***/ },
/* 27 */
/***/ function(module, exports, __webpack_require__) {

	var $ = __webpack_require__(24);
	module.exports = function create(P, D){
	  return $.create(P, D);
	};

/***/ },
/* 28 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	// 19.1.3.6 Object.prototype.toString()
	var cof = __webpack_require__(36)
	  , tmp = {};
	tmp[__webpack_require__(37)('toStringTag')] = 'z';
	if(__webpack_require__(24).FW && cof(tmp) != 'z'){
	  __webpack_require__(38)(Object.prototype, 'toString', function toString(){
	    return '[object ' + cof.classof(this) + ']';
	  }, true);
	}

/***/ },
/* 29 */
/***/ function(module, exports, __webpack_require__) {

	var set   = __webpack_require__(24).set
	  , $at   = __webpack_require__(41)(true)
	  , ITER  = __webpack_require__(42).safe('iter')
	  , $iter = __webpack_require__(43)
	  , step  = $iter.step;
	
	// 21.1.3.27 String.prototype[@@iterator]()
	__webpack_require__(44)(String, 'String', function(iterated){
	  set(this, ITER, {o: String(iterated), i: 0});
	// 21.1.5.2.1 %StringIteratorPrototype%.next()
	}, function(){
	  var iter  = this[ITER]
	    , O     = iter.o
	    , index = iter.i
	    , point;
	  if(index >= O.length)return step(1);
	  point = $at(O, index);
	  iter.i += point.length;
	  return step(0, point);
	});

/***/ },
/* 30 */
/***/ function(module, exports, __webpack_require__) {

	__webpack_require__(45);
	var $           = __webpack_require__(24)
	  , Iterators   = __webpack_require__(43).Iterators
	  , ITERATOR    = __webpack_require__(37)('iterator')
	  , ArrayValues = Iterators.Array
	  , NodeList    = $.g.NodeList;
	if($.FW && NodeList && !(ITERATOR in NodeList.prototype)){
	  $.hide(NodeList.prototype, ITERATOR, ArrayValues);
	}
	Iterators.NodeList = ArrayValues;

/***/ },
/* 31 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	var strong = __webpack_require__(39);
	
	// 23.1 Map Objects
	__webpack_require__(40)('Map', {
	  // 23.1.3.6 Map.prototype.get(key)
	  get: function get(key){
	    var entry = strong.getEntry(this, key);
	    return entry && entry.v;
	  },
	  // 23.1.3.9 Map.prototype.set(key, value)
	  set: function set(key, value){
	    return strong.def(this, key === 0 ? 0 : key, value);
	  }
	}, strong, true);

/***/ },
/* 32 */
/***/ function(module, exports, __webpack_require__) {

	// https://github.com/DavidBruant/Map-Set.prototype.toJSON
	__webpack_require__(46)('Map');

/***/ },
/* 33 */
/***/ function(module, exports, __webpack_require__) {

	var $ = __webpack_require__(24);
	__webpack_require__(47);
	module.exports = function getOwnPropertyDescriptor(it, key){
	  return $.getDesc(it, key);
	};

/***/ },
/* 34 */
/***/ function(module, exports, __webpack_require__) {

	var lookup = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
	
	;(function (exports) {
		'use strict';
	
	  var Arr = (typeof Uint8Array !== 'undefined')
	    ? Uint8Array
	    : Array
	
		var PLUS   = '+'.charCodeAt(0)
		var SLASH  = '/'.charCodeAt(0)
		var NUMBER = '0'.charCodeAt(0)
		var LOWER  = 'a'.charCodeAt(0)
		var UPPER  = 'A'.charCodeAt(0)
		var PLUS_URL_SAFE = '-'.charCodeAt(0)
		var SLASH_URL_SAFE = '_'.charCodeAt(0)
	
		function decode (elt) {
			var code = elt.charCodeAt(0)
			if (code === PLUS ||
			    code === PLUS_URL_SAFE)
				return 62 // '+'
			if (code === SLASH ||
			    code === SLASH_URL_SAFE)
				return 63 // '/'
			if (code < NUMBER)
				return -1 //no match
			if (code < NUMBER + 10)
				return code - NUMBER + 26 + 26
			if (code < UPPER + 26)
				return code - UPPER
			if (code < LOWER + 26)
				return code - LOWER + 26
		}
	
		function b64ToByteArray (b64) {
			var i, j, l, tmp, placeHolders, arr
	
			if (b64.length % 4 > 0) {
				throw new Error('Invalid string. Length must be a multiple of 4')
			}
	
			// the number of equal signs (place holders)
			// if there are two placeholders, than the two characters before it
			// represent one byte
			// if there is only one, then the three characters before it represent 2 bytes
			// this is just a cheap hack to not do indexOf twice
			var len = b64.length
			placeHolders = '=' === b64.charAt(len - 2) ? 2 : '=' === b64.charAt(len - 1) ? 1 : 0
	
			// base64 is 4/3 + up to two characters of the original data
			arr = new Arr(b64.length * 3 / 4 - placeHolders)
	
			// if there are placeholders, only get up to the last complete 4 chars
			l = placeHolders > 0 ? b64.length - 4 : b64.length
	
			var L = 0
	
			function push (v) {
				arr[L++] = v
			}
	
			for (i = 0, j = 0; i < l; i += 4, j += 3) {
				tmp = (decode(b64.charAt(i)) << 18) | (decode(b64.charAt(i + 1)) << 12) | (decode(b64.charAt(i + 2)) << 6) | decode(b64.charAt(i + 3))
				push((tmp & 0xFF0000) >> 16)
				push((tmp & 0xFF00) >> 8)
				push(tmp & 0xFF)
			}
	
			if (placeHolders === 2) {
				tmp = (decode(b64.charAt(i)) << 2) | (decode(b64.charAt(i + 1)) >> 4)
				push(tmp & 0xFF)
			} else if (placeHolders === 1) {
				tmp = (decode(b64.charAt(i)) << 10) | (decode(b64.charAt(i + 1)) << 4) | (decode(b64.charAt(i + 2)) >> 2)
				push((tmp >> 8) & 0xFF)
				push(tmp & 0xFF)
			}
	
			return arr
		}
	
		function uint8ToBase64 (uint8) {
			var i,
				extraBytes = uint8.length % 3, // if we have 1 byte left, pad 2 bytes
				output = "",
				temp, length
	
			function encode (num) {
				return lookup.charAt(num)
			}
	
			function tripletToBase64 (num) {
				return encode(num >> 18 & 0x3F) + encode(num >> 12 & 0x3F) + encode(num >> 6 & 0x3F) + encode(num & 0x3F)
			}
	
			// go through the array every three bytes, we'll deal with trailing stuff later
			for (i = 0, length = uint8.length - extraBytes; i < length; i += 3) {
				temp = (uint8[i] << 16) + (uint8[i + 1] << 8) + (uint8[i + 2])
				output += tripletToBase64(temp)
			}
	
			// pad the end with zeros, but make sure to not forget the extra bytes
			switch (extraBytes) {
				case 1:
					temp = uint8[uint8.length - 1]
					output += encode(temp >> 2)
					output += encode((temp << 4) & 0x3F)
					output += '=='
					break
				case 2:
					temp = (uint8[uint8.length - 2] << 8) + (uint8[uint8.length - 1])
					output += encode(temp >> 10)
					output += encode((temp >> 4) & 0x3F)
					output += encode((temp << 2) & 0x3F)
					output += '='
					break
			}
	
			return output
		}
	
		exports.toByteArray = b64ToByteArray
		exports.fromByteArray = uint8ToBase64
	}(false ? (this.base64js = {}) : exports))


/***/ },
/* 35 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = function($){
	  $.FW   = false;
	  $.path = $.core;
	  return $;
	};

/***/ },
/* 36 */
/***/ function(module, exports, __webpack_require__) {

	var $        = __webpack_require__(24)
	  , TAG      = __webpack_require__(37)('toStringTag')
	  , toString = {}.toString;
	function cof(it){
	  return toString.call(it).slice(8, -1);
	}
	cof.classof = function(it){
	  var O, T;
	  return it == undefined ? it === undefined ? 'Undefined' : 'Null'
	    : typeof (T = (O = Object(it))[TAG]) == 'string' ? T : cof(O);
	};
	cof.set = function(it, tag, stat){
	  if(it && !$.has(it = stat ? it : it.prototype, TAG))$.hide(it, TAG, tag);
	};
	module.exports = cof;

/***/ },
/* 37 */
/***/ function(module, exports, __webpack_require__) {

	var global = __webpack_require__(24).g
	  , store  = {};
	module.exports = function(name){
	  return store[name] || (store[name] =
	    global.Symbol && global.Symbol[name] || __webpack_require__(42).safe('Symbol.' + name));
	};

/***/ },
/* 38 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(24).hide;

/***/ },
/* 39 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	var $        = __webpack_require__(24)
	  , ctx      = __webpack_require__(48)
	  , safe     = __webpack_require__(42).safe
	  , assert   = __webpack_require__(49)
	  , forOf    = __webpack_require__(50)
	  , step     = __webpack_require__(43).step
	  , has      = $.has
	  , set      = $.set
	  , isObject = $.isObject
	  , hide     = $.hide
	  , isExtensible = Object.isExtensible || isObject
	  , ID       = safe('id')
	  , O1       = safe('O1')
	  , LAST     = safe('last')
	  , FIRST    = safe('first')
	  , ITER     = safe('iter')
	  , SIZE     = $.DESC ? safe('size') : 'size'
	  , id       = 0;
	
	function fastKey(it, create){
	  // return primitive with prefix
	  if(!isObject(it))return (typeof it == 'string' ? 'S' : 'P') + it;
	  if(!has(it, ID)){
	    // can't set id to frozen object
	    if(!isExtensible(it))return 'F';
	    // not necessary to add id
	    if(!create)return 'E';
	    // add missing object id
	    hide(it, ID, ++id);
	  // return object id with prefix
	  } return 'O' + it[ID];
	}
	
	function getEntry(that, key){
	  // fast case
	  var index = fastKey(key), entry;
	  if(index != 'F')return that[O1][index];
	  // frozen object case
	  for(entry = that[FIRST]; entry; entry = entry.n){
	    if(entry.k == key)return entry;
	  }
	}
	
	module.exports = {
	  getConstructor: function(NAME, IS_MAP, ADDER){
	    function C(){
	      var that     = assert.inst(this, C, NAME)
	        , iterable = arguments[0];
	      set(that, O1, $.create(null));
	      set(that, SIZE, 0);
	      set(that, LAST, undefined);
	      set(that, FIRST, undefined);
	      if(iterable != undefined)forOf(iterable, IS_MAP, that[ADDER], that);
	    }
	    __webpack_require__(51)(C.prototype, {
	      // 23.1.3.1 Map.prototype.clear()
	      // 23.2.3.2 Set.prototype.clear()
	      clear: function clear(){
	        for(var that = this, data = that[O1], entry = that[FIRST]; entry; entry = entry.n){
	          entry.r = true;
	          if(entry.p)entry.p = entry.p.n = undefined;
	          delete data[entry.i];
	        }
	        that[FIRST] = that[LAST] = undefined;
	        that[SIZE] = 0;
	      },
	      // 23.1.3.3 Map.prototype.delete(key)
	      // 23.2.3.4 Set.prototype.delete(value)
	      'delete': function(key){
	        var that  = this
	          , entry = getEntry(that, key);
	        if(entry){
	          var next = entry.n
	            , prev = entry.p;
	          delete that[O1][entry.i];
	          entry.r = true;
	          if(prev)prev.n = next;
	          if(next)next.p = prev;
	          if(that[FIRST] == entry)that[FIRST] = next;
	          if(that[LAST] == entry)that[LAST] = prev;
	          that[SIZE]--;
	        } return !!entry;
	      },
	      // 23.2.3.6 Set.prototype.forEach(callbackfn, thisArg = undefined)
	      // 23.1.3.5 Map.prototype.forEach(callbackfn, thisArg = undefined)
	      forEach: function forEach(callbackfn /*, that = undefined */){
	        var f = ctx(callbackfn, arguments[1], 3)
	          , entry;
	        while(entry = entry ? entry.n : this[FIRST]){
	          f(entry.v, entry.k, this);
	          // revert to the last existing entry
	          while(entry && entry.r)entry = entry.p;
	        }
	      },
	      // 23.1.3.7 Map.prototype.has(key)
	      // 23.2.3.7 Set.prototype.has(value)
	      has: function has(key){
	        return !!getEntry(this, key);
	      }
	    });
	    if($.DESC)$.setDesc(C.prototype, 'size', {
	      get: function(){
	        return assert.def(this[SIZE]);
	      }
	    });
	    return C;
	  },
	  def: function(that, key, value){
	    var entry = getEntry(that, key)
	      , prev, index;
	    // change existing entry
	    if(entry){
	      entry.v = value;
	    // create new entry
	    } else {
	      that[LAST] = entry = {
	        i: index = fastKey(key, true), // <- index
	        k: key,                        // <- key
	        v: value,                      // <- value
	        p: prev = that[LAST],          // <- previous entry
	        n: undefined,                  // <- next entry
	        r: false                       // <- removed
	      };
	      if(!that[FIRST])that[FIRST] = entry;
	      if(prev)prev.n = entry;
	      that[SIZE]++;
	      // add to index
	      if(index != 'F')that[O1][index] = entry;
	    } return that;
	  },
	  getEntry: getEntry,
	  // add .keys, .values, .entries, [@@iterator]
	  // 23.1.3.4, 23.1.3.8, 23.1.3.11, 23.1.3.12, 23.2.3.5, 23.2.3.8, 23.2.3.10, 23.2.3.11
	  setIter: function(C, NAME, IS_MAP){
	    __webpack_require__(44)(C, NAME, function(iterated, kind){
	      set(this, ITER, {o: iterated, k: kind});
	    }, function(){
	      var iter  = this[ITER]
	        , kind  = iter.k
	        , entry = iter.l;
	      // revert to the last existing entry
	      while(entry && entry.r)entry = entry.p;
	      // get next entry
	      if(!iter.o || !(iter.l = entry = entry ? entry.n : iter.o[FIRST])){
	        // or finish the iteration
	        iter.o = undefined;
	        return step(1);
	      }
	      // return step by kind
	      if(kind == 'keys'  )return step(0, entry.k);
	      if(kind == 'values')return step(0, entry.v);
	      return step(0, [entry.k, entry.v]);
	    }, IS_MAP ? 'entries' : 'values' , !IS_MAP, true);
	  }
	};

/***/ },
/* 40 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	var $     = __webpack_require__(24)
	  , $def  = __webpack_require__(52)
	  , BUGGY = __webpack_require__(43).BUGGY
	  , forOf = __webpack_require__(50)
	  , species = __webpack_require__(53)
	  , assertInstance = __webpack_require__(49).inst;
	
	module.exports = function(NAME, methods, common, IS_MAP, IS_WEAK){
	  var Base  = $.g[NAME]
	    , C     = Base
	    , ADDER = IS_MAP ? 'set' : 'add'
	    , proto = C && C.prototype
	    , O     = {};
	  function fixMethod(KEY, CHAIN){
	    if($.FW){
	      var method = proto[KEY];
	      __webpack_require__(38)(proto, KEY, function(a, b){
	        var result = method.call(this, a === 0 ? 0 : a, b);
	        return CHAIN ? this : result;
	      });
	    }
	  }
	  if(!$.isFunction(C) || !(IS_WEAK || !BUGGY && proto.forEach && proto.entries)){
	    // create collection constructor
	    C = common.getConstructor(NAME, IS_MAP, ADDER);
	    __webpack_require__(51)(C.prototype, methods);
	  } else {
	    var inst  = new C
	      , chain = inst[ADDER](IS_WEAK ? {} : -0, 1)
	      , buggyZero;
	    // wrap for init collections from iterable
	    if(!__webpack_require__(54)(function(iter){ new C(iter); })){ // eslint-disable-line no-new
	      C = function(){
	        assertInstance(this, C, NAME);
	        var that     = new Base
	          , iterable = arguments[0];
	        if(iterable != undefined)forOf(iterable, IS_MAP, that[ADDER], that);
	        return that;
	      };
	      C.prototype = proto;
	      if($.FW)proto.constructor = C;
	    }
	    IS_WEAK || inst.forEach(function(val, key){
	      buggyZero = 1 / key === -Infinity;
	    });
	    // fix converting -0 key to +0
	    if(buggyZero){
	      fixMethod('delete');
	      fixMethod('has');
	      IS_MAP && fixMethod('get');
	    }
	    // + fix .add & .set for chaining
	    if(buggyZero || chain !== inst)fixMethod(ADDER, true);
	  }
	
	  __webpack_require__(36).set(C, NAME);
	
	  O[NAME] = C;
	  $def($def.G + $def.W + $def.F * (C != Base), O);
	  species(C);
	  species($.core[NAME]); // for wrapper
	
	  if(!IS_WEAK)common.setIter(C, NAME, IS_MAP);
	
	  return C;
	};

/***/ },
/* 41 */
/***/ function(module, exports, __webpack_require__) {

	// true  -> String#at
	// false -> String#codePointAt
	var $ = __webpack_require__(24);
	module.exports = function(TO_STRING){
	  return function(that, pos){
	    var s = String($.assertDefined(that))
	      , i = $.toInteger(pos)
	      , l = s.length
	      , a, b;
	    if(i < 0 || i >= l)return TO_STRING ? '' : undefined;
	    a = s.charCodeAt(i);
	    return a < 0xd800 || a > 0xdbff || i + 1 === l
	      || (b = s.charCodeAt(i + 1)) < 0xdc00 || b > 0xdfff
	        ? TO_STRING ? s.charAt(i) : a
	        : TO_STRING ? s.slice(i, i + 2) : (a - 0xd800 << 10) + (b - 0xdc00) + 0x10000;
	  };
	};

/***/ },
/* 42 */
/***/ function(module, exports, __webpack_require__) {

	var sid = 0;
	function uid(key){
	  return 'Symbol('.concat(key === undefined ? '' : key, ')_', (++sid + Math.random()).toString(36));
	}
	uid.safe = __webpack_require__(24).g.Symbol || uid;
	module.exports = uid;

/***/ },
/* 43 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	var $                 = __webpack_require__(24)
	  , cof               = __webpack_require__(36)
	  , assertObject      = __webpack_require__(49).obj
	  , SYMBOL_ITERATOR   = __webpack_require__(37)('iterator')
	  , FF_ITERATOR       = '@@iterator'
	  , Iterators         = {}
	  , IteratorPrototype = {};
	// 25.1.2.1.1 %IteratorPrototype%[@@iterator]()
	setIterator(IteratorPrototype, $.that);
	function setIterator(O, value){
	  $.hide(O, SYMBOL_ITERATOR, value);
	  // Add iterator for FF iterator protocol
	  if(FF_ITERATOR in [])$.hide(O, FF_ITERATOR, value);
	}
	
	module.exports = {
	  // Safari has buggy iterators w/o `next`
	  BUGGY: 'keys' in [] && !('next' in [].keys()),
	  Iterators: Iterators,
	  step: function(done, value){
	    return {value: value, done: !!done};
	  },
	  is: function(it){
	    var O      = Object(it)
	      , Symbol = $.g.Symbol
	      , SYM    = Symbol && Symbol.iterator || FF_ITERATOR;
	    return SYM in O || SYMBOL_ITERATOR in O || $.has(Iterators, cof.classof(O));
	  },
	  get: function(it){
	    var Symbol  = $.g.Symbol
	      , ext     = it[Symbol && Symbol.iterator || FF_ITERATOR]
	      , getIter = ext || it[SYMBOL_ITERATOR] || Iterators[cof.classof(it)];
	    return assertObject(getIter.call(it));
	  },
	  set: setIterator,
	  create: function(Constructor, NAME, next, proto){
	    Constructor.prototype = $.create(proto || IteratorPrototype, {next: $.desc(1, next)});
	    cof.set(Constructor, NAME + ' Iterator');
	  }
	};

/***/ },
/* 44 */
/***/ function(module, exports, __webpack_require__) {

	var $def            = __webpack_require__(52)
	  , $redef          = __webpack_require__(38)
	  , $               = __webpack_require__(24)
	  , cof             = __webpack_require__(36)
	  , $iter           = __webpack_require__(43)
	  , SYMBOL_ITERATOR = __webpack_require__(37)('iterator')
	  , FF_ITERATOR     = '@@iterator'
	  , KEYS            = 'keys'
	  , VALUES          = 'values'
	  , Iterators       = $iter.Iterators;
	module.exports = function(Base, NAME, Constructor, next, DEFAULT, IS_SET, FORCE){
	  $iter.create(Constructor, NAME, next);
	  function createMethod(kind){
	    function $$(that){
	      return new Constructor(that, kind);
	    }
	    switch(kind){
	      case KEYS: return function keys(){ return $$(this); };
	      case VALUES: return function values(){ return $$(this); };
	    } return function entries(){ return $$(this); };
	  }
	  var TAG      = NAME + ' Iterator'
	    , proto    = Base.prototype
	    , _native  = proto[SYMBOL_ITERATOR] || proto[FF_ITERATOR] || DEFAULT && proto[DEFAULT]
	    , _default = _native || createMethod(DEFAULT)
	    , methods, key;
	  // Fix native
	  if(_native){
	    var IteratorPrototype = $.getProto(_default.call(new Base));
	    // Set @@toStringTag to native iterators
	    cof.set(IteratorPrototype, TAG, true);
	    // FF fix
	    if($.FW && $.has(proto, FF_ITERATOR))$iter.set(IteratorPrototype, $.that);
	  }
	  // Define iterator
	  if($.FW)$iter.set(proto, _default);
	  // Plug for library
	  Iterators[NAME] = _default;
	  Iterators[TAG]  = $.that;
	  if(DEFAULT){
	    methods = {
	      keys:    IS_SET            ? _default : createMethod(KEYS),
	      values:  DEFAULT == VALUES ? _default : createMethod(VALUES),
	      entries: DEFAULT != VALUES ? _default : createMethod('entries')
	    };
	    if(FORCE)for(key in methods){
	      if(!(key in proto))$redef(proto, key, methods[key]);
	    } else $def($def.P + $def.F * $iter.BUGGY, NAME, methods);
	  }
	};

/***/ },
/* 45 */
/***/ function(module, exports, __webpack_require__) {

	var $          = __webpack_require__(24)
	  , setUnscope = __webpack_require__(55)
	  , ITER       = __webpack_require__(42).safe('iter')
	  , $iter      = __webpack_require__(43)
	  , step       = $iter.step
	  , Iterators  = $iter.Iterators;
	
	// 22.1.3.4 Array.prototype.entries()
	// 22.1.3.13 Array.prototype.keys()
	// 22.1.3.29 Array.prototype.values()
	// 22.1.3.30 Array.prototype[@@iterator]()
	__webpack_require__(44)(Array, 'Array', function(iterated, kind){
	  $.set(this, ITER, {o: $.toObject(iterated), i: 0, k: kind});
	// 22.1.5.2.1 %ArrayIteratorPrototype%.next()
	}, function(){
	  var iter  = this[ITER]
	    , O     = iter.o
	    , kind  = iter.k
	    , index = iter.i++;
	  if(!O || index >= O.length){
	    iter.o = undefined;
	    return step(1);
	  }
	  if(kind == 'keys'  )return step(0, index);
	  if(kind == 'values')return step(0, O[index]);
	  return step(0, [index, O[index]]);
	}, 'values');
	
	// argumentsList[@@iterator] is %ArrayProto_values% (9.4.4.6, 9.4.4.7)
	Iterators.Arguments = Iterators.Array;
	
	setUnscope('keys');
	setUnscope('values');
	setUnscope('entries');

/***/ },
/* 46 */
/***/ function(module, exports, __webpack_require__) {

	// https://github.com/DavidBruant/Map-Set.prototype.toJSON
	var $def  = __webpack_require__(52)
	  , forOf = __webpack_require__(50);
	module.exports = function(NAME){
	  $def($def.P, NAME, {
	    toJSON: function toJSON(){
	      var arr = [];
	      forOf(this, false, arr.push, arr);
	      return arr;
	    }
	  });
	};

/***/ },
/* 47 */
/***/ function(module, exports, __webpack_require__) {

	var $        = __webpack_require__(24)
	  , $def     = __webpack_require__(52)
	  , isObject = $.isObject
	  , toObject = $.toObject;
	$.each.call(('freeze,seal,preventExtensions,isFrozen,isSealed,isExtensible,' +
	  'getOwnPropertyDescriptor,getPrototypeOf,keys,getOwnPropertyNames').split(',')
	, function(KEY, ID){
	  var fn     = ($.core.Object || {})[KEY] || Object[KEY]
	    , forced = 0
	    , method = {};
	  method[KEY] = ID == 0 ? function freeze(it){
	    return isObject(it) ? fn(it) : it;
	  } : ID == 1 ? function seal(it){
	    return isObject(it) ? fn(it) : it;
	  } : ID == 2 ? function preventExtensions(it){
	    return isObject(it) ? fn(it) : it;
	  } : ID == 3 ? function isFrozen(it){
	    return isObject(it) ? fn(it) : true;
	  } : ID == 4 ? function isSealed(it){
	    return isObject(it) ? fn(it) : true;
	  } : ID == 5 ? function isExtensible(it){
	    return isObject(it) ? fn(it) : false;
	  } : ID == 6 ? function getOwnPropertyDescriptor(it, key){
	    return fn(toObject(it), key);
	  } : ID == 7 ? function getPrototypeOf(it){
	    return fn(Object($.assertDefined(it)));
	  } : ID == 8 ? function keys(it){
	    return fn(toObject(it));
	  } : function getOwnPropertyNames(it){
	    return fn(toObject(it));
	  };
	  try {
	    fn('z');
	  } catch(e){
	    forced = 1;
	  }
	  $def($def.S + $def.F * forced, 'Object', method);
	});

/***/ },
/* 48 */
/***/ function(module, exports, __webpack_require__) {

	// Optional / simple context binding
	var assertFunction = __webpack_require__(49).fn;
	module.exports = function(fn, that, length){
	  assertFunction(fn);
	  if(~length && that === undefined)return fn;
	  switch(length){
	    case 1: return function(a){
	      return fn.call(that, a);
	    };
	    case 2: return function(a, b){
	      return fn.call(that, a, b);
	    };
	    case 3: return function(a, b, c){
	      return fn.call(that, a, b, c);
	    };
	  } return function(/* ...args */){
	      return fn.apply(that, arguments);
	    };
	};

/***/ },
/* 49 */
/***/ function(module, exports, __webpack_require__) {

	var $ = __webpack_require__(24);
	function assert(condition, msg1, msg2){
	  if(!condition)throw TypeError(msg2 ? msg1 + msg2 : msg1);
	}
	assert.def = $.assertDefined;
	assert.fn = function(it){
	  if(!$.isFunction(it))throw TypeError(it + ' is not a function!');
	  return it;
	};
	assert.obj = function(it){
	  if(!$.isObject(it))throw TypeError(it + ' is not an object!');
	  return it;
	};
	assert.inst = function(it, Constructor, name){
	  if(!(it instanceof Constructor))throw TypeError(name + ": use the 'new' operator!");
	  return it;
	};
	module.exports = assert;

/***/ },
/* 50 */
/***/ function(module, exports, __webpack_require__) {

	var ctx  = __webpack_require__(48)
	  , get  = __webpack_require__(43).get
	  , call = __webpack_require__(56);
	module.exports = function(iterable, entries, fn, that){
	  var iterator = get(iterable)
	    , f        = ctx(fn, that, entries ? 2 : 1)
	    , step;
	  while(!(step = iterator.next()).done){
	    if(call(iterator, f, step.value, entries) === false){
	      return call.close(iterator);
	    }
	  }
	};

/***/ },
/* 51 */
/***/ function(module, exports, __webpack_require__) {

	var $redef = __webpack_require__(38);
	module.exports = function(target, src){
	  for(var key in src)$redef(target, key, src[key]);
	  return target;
	};

/***/ },
/* 52 */
/***/ function(module, exports, __webpack_require__) {

	var $          = __webpack_require__(24)
	  , global     = $.g
	  , core       = $.core
	  , isFunction = $.isFunction;
	function ctx(fn, that){
	  return function(){
	    return fn.apply(that, arguments);
	  };
	}
	// type bitmap
	$def.F = 1;  // forced
	$def.G = 2;  // global
	$def.S = 4;  // static
	$def.P = 8;  // proto
	$def.B = 16; // bind
	$def.W = 32; // wrap
	function $def(type, name, source){
	  var key, own, out, exp
	    , isGlobal = type & $def.G
	    , isProto  = type & $def.P
	    , target   = isGlobal ? global : type & $def.S
	        ? global[name] : (global[name] || {}).prototype
	    , exports  = isGlobal ? core : core[name] || (core[name] = {});
	  if(isGlobal)source = name;
	  for(key in source){
	    // contains in native
	    own = !(type & $def.F) && target && key in target;
	    if(own && key in exports)continue;
	    // export native or passed
	    out = own ? target[key] : source[key];
	    // prevent global pollution for namespaces
	    if(isGlobal && !isFunction(target[key]))exp = source[key];
	    // bind timers to global for call from export context
	    else if(type & $def.B && own)exp = ctx(out, global);
	    // wrap global constructors for prevent change them in library
	    else if(type & $def.W && target[key] == out)!function(C){
	      exp = function(param){
	        return this instanceof C ? new C(param) : C(param);
	      };
	      exp.prototype = C.prototype;
	    }(out);
	    else exp = isProto && isFunction(out) ? ctx(Function.call, out) : out;
	    // export
	    exports[key] = exp;
	    if(isProto)(exports.prototype || (exports.prototype = {}))[key] = out;
	  }
	}
	module.exports = $def;

/***/ },
/* 53 */
/***/ function(module, exports, __webpack_require__) {

	var $       = __webpack_require__(24)
	  , SPECIES = __webpack_require__(37)('species');
	module.exports = function(C){
	  if($.DESC && !(SPECIES in C))$.setDesc(C, SPECIES, {
	    configurable: true,
	    get: $.that
	  });
	};

/***/ },
/* 54 */
/***/ function(module, exports, __webpack_require__) {

	var SYMBOL_ITERATOR = __webpack_require__(37)('iterator')
	  , SAFE_CLOSING    = false;
	try {
	  var riter = [7][SYMBOL_ITERATOR]();
	  riter['return'] = function(){ SAFE_CLOSING = true; };
	  Array.from(riter, function(){ throw 2; });
	} catch(e){ /* empty */ }
	module.exports = function(exec){
	  if(!SAFE_CLOSING)return false;
	  var safe = false;
	  try {
	    var arr  = [7]
	      , iter = arr[SYMBOL_ITERATOR]();
	    iter.next = function(){ safe = true; };
	    arr[SYMBOL_ITERATOR] = function(){ return iter; };
	    exec(arr);
	  } catch(e){ /* empty */ }
	  return safe;
	};

/***/ },
/* 55 */
/***/ function(module, exports, __webpack_require__) {

	// 22.1.3.31 Array.prototype[@@unscopables]
	var $           = __webpack_require__(24)
	  , UNSCOPABLES = __webpack_require__(37)('unscopables');
	if($.FW && !(UNSCOPABLES in []))$.hide(Array.prototype, UNSCOPABLES, {});
	module.exports = function(key){
	  if($.FW)[][UNSCOPABLES][key] = true;
	};

/***/ },
/* 56 */
/***/ function(module, exports, __webpack_require__) {

	var assertObject = __webpack_require__(49).obj;
	function close(iterator){
	  var ret = iterator['return'];
	  if(ret !== undefined)assertObject(ret.call(iterator));
	}
	function call(iterator, fn, value, entries){
	  try {
	    return entries ? fn(assertObject(value)[0], value[1]) : fn(value);
	  } catch(e){
	    close(iterator);
	    throw e;
	  }
	}
	call.close = close;
	module.exports = call;

/***/ }
/******/ ])
});
;
//# sourceMappingURL=msgpack-javascript.js.map